#!/usr/bin/python3
# -*- coding: utf-8 -*-

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk, Gdk, GdkPixbuf
from os.path import expanduser
import os
import shutil
import getpass
import configparser
import subprocess
import time
import gettext, locale

entorno_usu = locale.getlocale()[0]
if entorno_usu.find("en") >= 0 or entorno_usu.find("es") >= 0 or entorno_usu.find("it") >= 0 or entorno_usu.find("pt") >= 0 or entorno_usu.find("gl") >= 0:
	idiomas = [entorno_usu]
else:
	idiomas = ['en']

print('Language: ', entorno_usu)

t = gettext.translation('preferences',
                        '/usr/share/slimbookbattery/locale',
                        languages=idiomas,
                        fallback=True,)

_ = t.gettext

user = expanduser("~")

config = configparser.ConfigParser()
config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')

adjustment2 = Gtk.Adjustment.new(0, 0, 100, 5, 5, 0)

class PreferencesDialog(Gtk.Dialog):
	def __init__(self):
		Gtk.Dialog.__init__(self,
			(_('strdialogtitle')),
			None,
			Gtk.DialogFlags.MODAL |
			Gtk.DialogFlags.DESTROY_WITH_PARENT)
		self.RestoreValues = self.add_button((_('strrestorebutton')), 1)
		self.RestoreValues.connect("clicked", self.on_buttonRestGeneral_clicked)
		self.add_buttons(Gtk.STOCK_CANCEL, Gtk.ResponseType.REJECT)
		self.add_buttons(Gtk.STOCK_OK, Gtk.ResponseType.ACCEPT)
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.connect("close", self.close_ok)
		icon_name = 'slimbookbatterypreferences'
		icon_theme = Gtk.IconTheme.get_default()
		icon = icon_theme.lookup_icon(icon_name, 48, 0)
		pixbuf = icon_theme.load_icon(icon_name, 48, 0)
		self.set_default_icon_list([pixbuf])
		#self.set_icon_from_file('/usr/share/pixmaps/slimbookbatterypreferences.png')
		dimensiones = subprocess.getoutput("xdpyinfo | grep 'dimensions:'")
		dimensiones = dimensiones.split()
		dimensiones = dimensiones[1]
		dimensiones = dimensiones.split('x')
		ancho = dimensiones[0]
		alto = dimensiones[1]
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			print(_('strprintwindowsize'))
		else:
			self.set_default_size(1100, 400)
		self.set_resizable(False)
		#
		vbox0 = Gtk.VBox(spacing=5)
		vbox0.set_border_width(5)
		self.get_content_area().add(vbox0)
		'''
		self.statusbar = Gtk.Statusbar()
		self.context_id = self.statusbar.get_context_id('')
		self.statusbar.push(self.context_id, "*The remaining battery time may take a few minutes to change.")
		self.get_content_area().add(self.statusbar)
		'''
		# ***************************************************************
		notebook = Gtk.Notebook.new()
		vbox0.add(notebook)
		# ********* PAGE 1 **********************************************
		vbox1 = Gtk.VBox(spacing=5)
		vbox1.set_border_width(5)
		print((_('strprintancho')) +str(ancho)+ (_('strprintalto')) +str(alto))
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox1, Gtk.Label.new(_('strpagegeneral')))
		else:
			scrolled_window1 = Gtk.ScrolledWindow()
			scrolled_window1.set_border_width(10)
			scrolled_window1.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window1.set_min_content_height(400)
			scrolled_window1.set_min_content_width(1000)

			notebook.append_page(scrolled_window1, Gtk.Label.new(_('strpagegeneral')))
			scrolled_window1.add_with_viewport(vbox1)
		frame1 = Gtk.Frame()
		vbox1.pack_start(frame1, False, False, 1)
		table1 = Gtk.Table(3, 3, False)
		frame1.add(table1)
		# ********* PAGE 2 **********************************************
		vbox2 = Gtk.VBox(spacing=5)
		vbox2.set_border_width(5)
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox2, Gtk.Label.new(_('strpagecycles')))
		else:
			scrolled_window2 = Gtk.ScrolledWindow()
			scrolled_window2.set_border_width(10)
			scrolled_window2.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window2.set_min_content_height(400)
			scrolled_window2.set_min_content_width(1000)

			notebook.append_page(scrolled_window2, Gtk.Label.new(_('strpagecycles')))
			scrolled_window2.add_with_viewport(vbox2)
		frame2 = Gtk.Frame()
		vbox2.pack_start(frame2, False, False, 1)
		table2 = Gtk.Table(3, 3, False)
		frame2.add(table2)
		# ********* PAGE 3 **********************************************
		vbox3 = Gtk.VBox(spacing=5)
		vbox3.set_border_width(5)
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox3, Gtk.Label.new(_('strenergysaving')))
		else:
			scrolled_window3 = Gtk.ScrolledWindow()
			scrolled_window3.set_border_width(10)
			scrolled_window3.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window3.set_min_content_height(400)
			scrolled_window3.set_min_content_width(1000)

			notebook.append_page(scrolled_window3, Gtk.Label.new(_('strenergysaving')))
			scrolled_window3.add_with_viewport(vbox3)
		frame3 = Gtk.Frame()
		vbox3.pack_start(frame3, False, False, 1)
		table3 = Gtk.Table(3, 3, False)
		frame3.add(table3)
		# ********* PAGE 4 **********************************************
		vbox4 = Gtk.VBox(spacing=5)
		vbox4.set_border_width(5)
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox4, Gtk.Label.new(_('strbalanced')))
		else:
			scrolled_window4 = Gtk.ScrolledWindow()
			scrolled_window4.set_border_width(10)
			scrolled_window4.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window4.set_min_content_height(400)
			scrolled_window4.set_min_content_width(1000)

			notebook.append_page(scrolled_window4, Gtk.Label.new(_('strbalanced')))
			scrolled_window4.add_with_viewport(vbox4)
		frame4 = Gtk.Frame()
		vbox4.pack_start(frame4, False, False, 1)
		table4 = Gtk.Table(3, 3, False)
		frame4.add(table4)
		# ********* PAGE 5 **********************************************
		vbox5 = Gtk.VBox(spacing=5)
		vbox5.set_border_width(5)
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox5, Gtk.Label.new(_('strmaximumperformance')))
		else:
			scrolled_window5 = Gtk.ScrolledWindow()
			scrolled_window5.set_border_width(10)
			scrolled_window5.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window5.set_min_content_height(400)
			scrolled_window5.set_min_content_width(1000)

			notebook.append_page(scrolled_window5, Gtk.Label.new(_('strmaximumperformance')))
			scrolled_window5.add_with_viewport(vbox5)
		frame5 = Gtk.Frame()
		vbox5.pack_start(frame5, False, False, 1)
		table5 = Gtk.Table(3, 3, False)
		frame5.add(table5)
		# ********* PAGE 6 ***********************************************
		vbox6 = Gtk.VBox(spacing=5)
		vbox6.set_border_width(5)
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox6, Gtk.Label.new(_('strpagebattery')))
		else:
			scrolled_window6 = Gtk.ScrolledWindow()
			scrolled_window6.set_border_width(10)
			scrolled_window6.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window6.set_min_content_height(400)
			scrolled_window6.set_min_content_width(1000)

			notebook.append_page(scrolled_window6, Gtk.Label.new(_('strpagebattery')))
			scrolled_window6.add_with_viewport(vbox6)
		frame6 = Gtk.Frame()
		vbox6.pack_start(frame6, False, False, 1)
		table6 = Gtk.Table(3, 3, False)
		frame6.add(table6)
		# ********* PAGE 7 ***********************************************
		vbox7 = Gtk.VBox(spacing=5)
		vbox7.set_border_width(5)
		if (int(ancho) >= 1920) and (int(alto) >= 1080):
			notebook.append_page(vbox7, Gtk.Label.new(_('strpageinfo')))
		else:
			scrolled_window7 = Gtk.ScrolledWindow()
			scrolled_window7.set_border_width(10)
			scrolled_window7.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
			scrolled_window7.set_min_content_height(400)
			scrolled_window7.set_min_content_width(1000)

			notebook.append_page(scrolled_window7, Gtk.Label.new(_('strpageinfo')))
			scrolled_window7.add_with_viewport(vbox7)
		frame7 = Gtk.Frame()
		vbox7.pack_start(frame7, False, False, 1)
		table7 = Gtk.Table(3, 3, False)
		frame7.add(table7)
		# ***************************************************************
		# ---------------------------- GENERAL --------------------------------
		# (0, 0)
		label11 = Gtk.Label(_('strswitchonoff'))
		label11.set_alignment(0, 0.5)
		table1.attach(label11, 0, 1, 0, 1, xpadding=60, ypadding=5)
		# (0, 1)
		self.switchOnOff = Gtk. Switch()
		self.switchOnOff.set_active(self.check_autostart_switchOnOff(self.switchOnOff))
		table1.attach(self.switchOnOff, 1, 2, 0, 1,
			xpadding=5,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (1, 0)
		label11 = Gtk.Label(_('strswitchautostart'))
		label11.set_alignment(0, 0.5)
		table1.attach(label11, 0, 1, 1, 2, xpadding=60, ypadding=5)
		# (1, 1)
		self.switchAutostart = Gtk.Switch()
		self.switchAutostart.set_active(self.check_autostart_switchAutostart(self.switchAutostart))
		table1.attach(self.switchAutostart, 1, 2, 1, 2,
			xpadding=5,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (2, 0)
		label11  = Gtk.Label(_('strselectmode'))
		label11.set_alignment(0, 0.5)
		table1.attach(label11, 0, 1, 2, 3, xpadding=60, ypadding=5)
		# (2, 1)
		store = Gtk.ListStore(int, str)
		store.append([1, (_('strenergysaving'))])
		store.append([2, (_('strbalanced'))])
		store.append([3, (_('strmaximumperformance'))])
		self.comboBoxActualMode = Gtk.ComboBox.new_with_model_and_entry(store)
		self.comboBoxActualMode.set_entry_text_column(1)
		self.comboBoxActualMode.set_active(self.check_autostart_ActualMode(self.comboBoxActualMode))
		table1.attach(self.comboBoxActualMode, 1, 2, 2, 3,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		'''# (5, 0)
		label11 = Gtk.Label('Show time to empty:')
		label11.set_alignment(0, 0.5)
		table1.attach(label11, 0, 1, 6, 7, xpadding=60, ypadding=5)
		# (5, 1)
		self.switch2 = Gtk.Switch()
		#self.switch2.connect("notify::active", self.on_switch_activated)
		self.switch2.set_active(self.check_autostart2(self.switch2))
		table1.attach(self.switch2, 1, 2, 6, 7,
			xpadding=5,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK)'''
		# (3, 0)
		label11 = Gtk.Label(_('strworkingmode'))
		label11.set_alignment(0, 0.5)
		table1.attach(label11, 0, 1, 3, 4, xpadding=60, ypadding=5)
		# (3, 1)
		store = Gtk.ListStore(int, str)
		store.append([1, 'AC'])
		store.append([2, 'BAT'])
		self.comboBoxWorkMode = Gtk.ComboBox.new_with_model_and_entry(store)
		self.comboBoxWorkMode.set_entry_text_column(1)
		self.comboBoxWorkMode.set_active(self.check_autostart_WorkMode(self.comboBoxWorkMode))
		table1.attach(self.comboBoxWorkMode, 1, 2, 3, 4,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (4, 0)
		table_icon = Gtk.Table(2, 1, False)
		table1.attach(table_icon, 0, 1, 4, 5, xpadding=60, ypadding=5)
		label11 = Gtk.Label(_('striconapp'))
		label11.set_alignment(0, 0.5)
		table_icon.attach(label11, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strhelpiconapp'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (4, 1)
		self.switchIcon = Gtk.Switch()
		self.switchIcon.set_active(self.check_autostart_switchIcon(self.switchIcon))
		table1.attach(self.switchIcon, 1, 2, 4, 5,
			xpadding=5,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (5, 0)
		if os.system("cat /sys/power/state | grep disk") == 0:
			label11 = Gtk.Label(_('strhibernate'))
			label11.set_alignment(0, 0.5)
			table1.attach(label11, 0, 1, 5, 6, xpadding=60, ypadding=5)
			# (5, 1)
			self.switchHibernate = Gtk.Switch()
			self.switchHibernate.set_active(self.check_autostart_switchHibernate(self.switchHibernate))
			table1.attach(self.switchHibernate, 1, 2, 5, 6,
				xpadding=5,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)
		# ***************************************************************
		# -------------------------------- AHORRO DE ENERGIA --------------------------------
		pos1 = 0
		pos2 = 1
		# (0, 0)
		label33 = Gtk.Label('')
		label33.set_markup('<big><b>'+ (_('strtitlebatparams')) +'</b></big>')
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 2, pos1, pos2, xpadding=60, ypadding=8)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (1, 0)
		table_icon = Gtk.Table(2, 1, False)
		table3.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label33 = Gtk.Label(_('strlimitcpu'))
		label33.set_alignment(0, 0.5)
		table_icon.attach(label33, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/warning.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strlimitcputooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (1, 1)
		store = Gtk.ListStore(int, str)
		store.append([1, (_('strmaximumlimitcpu'))])
		store.append([2, (_('strmediumlimitcpu'))])
		store.append([3, (_('strnonelimitcpu'))])
		self.comboBoxLimitCPU = Gtk.ComboBox.new_with_model_and_entry(store)
		self.comboBoxLimitCPU.set_entry_text_column(1)
		self.comboBoxLimitCPU.set_active(self.check_autostart_comboBoxLimitCPU(self.comboBoxLimitCPU))
		table3.attach(self.comboBoxLimitCPU, 1, 2, pos1, pos2,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (2, 0)
		governorCompatible, governor_name = governorIsCompatible()
		if governorCompatible == True:
			label33 = Gtk.Label(_('strgovernorcpu'))
			label33.set_alignment(0, 0.5)
			table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
			# (2, 1)
			store = Gtk.ListStore(int, str)
			store.append([1, 'powersave'])
			self.comboBoxGovernor = Gtk.ComboBox.new_with_model_and_entry(store)
			self.comboBoxGovernor.set_entry_text_column(1)
			self.comboBoxGovernor.set_active(0)
			self.comboBoxGovernor.set_sensitive(False)
			table3.attach(self.comboBoxGovernor, 1, 2, pos1, pos2,
				xpadding=0,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)

			pos1 = pos1 + 1
			pos2 = pos2 + 1
		# (3, 0)
		label33 = Gtk.Label(_('strgraphicssaving'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (3, 1)
		self.switchGraphics = Gtk.Switch()
		self.switchGraphics.set_active(self.check_autostart_switchGraphics(self.switchGraphics))
		table3.attach(self.switchGraphics, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (4, 0)
		table_icon = Gtk.Table(2, 1, False)
		table3.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label33 = Gtk.Label(_('strsoundsaving'))
		label33.set_alignment(0, 0.5)
		table_icon.attach(label33, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strsoundtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (4, 1)
		self.switchSound = Gtk.Switch()
		self.switchSound.set_active(self.check_autostart_switchSound(self.switchSound))
		table3.attach(self.switchSound, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (5, 0)
		table_icon = Gtk.Table(2, 1, False)
		table3.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label33 = Gtk.Label(_('strwifisaving'))
		label33.set_alignment(0, 0.5)
		table_icon.attach(label33, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strwifisavingtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (5, 1)
		self.switchWifiPower = Gtk.Switch()
		self.switchWifiPower.set_active(self.check_autostart_switchWifiPower(self.switchWifiPower))
		table3.attach(self.switchWifiPower, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (6, 0)
		label33 = Gtk.Label(_('strbluetoothniu'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (6, 1)
		self.switchBluetoothNIU =Gtk.Switch()
		self.switchBluetoothNIU.set_active(self.check_autostart_switchBluetoothNIU(self.switchBluetoothNIU))
		table3.attach(self.switchBluetoothNIU, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (7, 0)
		label33 = Gtk.Label(_('strwifiniu'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (7, 1)
		self.switchWifiNIU = Gtk.Switch()
		self.switchWifiNIU.set_active(self.check_autostart_switchWifiNIU(self.switchWifiNIU))
		table3.attach(self.switchWifiNIU, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (8, 0)
		label33 = Gtk.Label('')
		label33.set_markup('<big><b>'+ (_('strpersistentparams')) +'</b></big>')
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (9, 0)
		table_icon = Gtk.Table(2, 1, False)
		table3.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label33 = Gtk.Label(_('strbrightness'))
		label33.set_alignment(0, 0.5)
		table_icon.attach(label33, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strbirghtnesstooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (9, 1)
		self.scaleBrightness = Gtk.Scale()
		self.scaleBrightness.set_size_request(200, 10)
		ahorroBrightness = self.check_ahorroBrightness()
		self.scaleBrightness.set_adjustment(Gtk.Adjustment.new(int(ahorroBrightness), 10, 80, 5, 5, 0))
		self.scaleBrightness.set_digits(0)
		self.scaleBrightness.set_hexpand(True)
		table3.attach(self.scaleBrightness, 1, 2, pos1, pos2, xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		
		if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
			# (10, 0)
			label33 = Gtk.Label(_('strdisanimations'))
			label33.set_alignment(0, 0.5)
			table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
			# (10, 1)
			self.switchAnimations = Gtk.Switch()
			self.switchAnimations.set_active(self.check_autostart_switchAnimations(self.switchAnimations))
			table3.attach(self.switchAnimations, 1, 2, pos1, pos2,
				xpadding=60,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)
			
			pos1 = pos1 + 1
			pos2 = pos2 + 1
		# (11, 0)
		label33 = Gtk.Label(_("strbluetoothdbos"))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (11, 1)
		self.switchBluetoothOS = Gtk.Switch()
		self.switchBluetoothOS.set_active(self.check_autostart_switchBluetoothOS(self.switchBluetoothOS))
		table3.attach(self.switchBluetoothOS, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (12, 0)
		label33 = Gtk.Label(_("strwifidbos"))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (12, 1)
		self.switchWifiOS = Gtk.Switch()
		self.switchWifiOS.set_active(self.check_autostart_switchWifiOS(self.switchWifiOS))
		table3.attach(self.switchWifiOS, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (13, 0)
		label33 = Gtk.Label(_('strwifionlanconn'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (13, 1)
		self.switchWifiDisableLAN = Gtk.Switch()
		self.switchWifiDisableLAN.set_active(self.check_autostart_switchDisableLAN(self.switchWifiDisableLAN))
		table3.attach(self.switchWifiDisableLAN, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (14, 0)
		table_icon = Gtk.Table(2, 1, False)
		table3.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label33 = Gtk.Label(_('strautosuspendusb'))
		label33.set_alignment(0, 0.5)
		table_icon.attach(label33, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strautosuspendusbtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (14, 1)
		self.switchUSBSuspend = Gtk.Switch()
		self.switchUSBSuspend.set_active(self.check_autostart_USBSuspend(self.switchUSBSuspend))
		self.switchUSBSuspend.connect("notify::active", self.on_switchUSBSuspend_change)
		table3.attach(self.switchUSBSuspend, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (15, 0)
		table_icon = Gtk.Table(2, 1, False)
		table3.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label33 = Gtk.Label(_('strexcludedusbids'))
		label33.set_alignment(0, 0.5)
		table_icon.attach(label33, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		#Se leen los diferentes USB que hay disponibles y se almacenan en un archivo temporalmente
		os.system('lsusb | grep ID > '+ user +'/.config/slimbookbattery/usbidlist')
		USBIDsList = ''
		#Se lee el archivo temporal que se ha creado y se va sacando para que solo nos muestre el ID junto con el nombre del USB
		f = open(user +'/.config/slimbookbattery/usbidlist', 'r')
		line = f.readline()
		while line:
			lineaActual = line
			#Saca la posición del ID en la linea
			IDPos = lineaActual.find("ID")
			#Saca la última posición de la linea
			longitud = len(lineaActual) - 1
			#Una vez teniendo estas 2 posiciones ya tenemos el ID junto con el nombre del USB y se concatena al string USBIDsList
			USBIDsList = USBIDsList + lineaActual[IDPos:longitud] +'\n'
			line = f.readline()
		f.close()
		#Se elimina el archivo temporal
		os.system('rm '+ user +'/.config/slimbookbattery/usbidlist')
		#En este tooltip
		icon.set_tooltip_text((_('strexcludedusbtooltip')) +'.\n\n'+USBIDsList)
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1,
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (15, 1)
		self.entryBlacklistUSBIDs = Gtk.Entry()
		if self.check_autostart_USBSuspend(self.switchUSBSuspend) == False:
			self.entryBlacklistUSBIDs.set_text('')
			self.entryBlacklistUSBIDs.set_sensitive(False)
		else:
			self.entryBlacklistUSBIDs.set_text(str(self.check_autostart_BlacklistUSBIDs(self.entryBlacklistUSBIDs)))
			self.entryBlacklistUSBIDs.set_sensitive(True)
		table3.attach(self.entryBlacklistUSBIDs, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (16, 0)
		label33 = Gtk.Label(_('strusbexcludebluetooth'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (16, 1)
		self.switchBlacklistBUSB = Gtk.Switch()
		if self.check_autostart_USBSuspend(self.switchUSBSuspend) == False:
			self.switchBlacklistBUSB.set_active(False)
			self.switchBlacklistBUSB.set_sensitive(False)
		else:
			self.switchBlacklistBUSB.set_active(self.check_autostart_BlacklistBUSB(self.switchBlacklistBUSB))
			self.switchBlacklistBUSB.set_sensitive(True)
		table3.attach(self.switchBlacklistBUSB, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		'''# (17, 0)
		label33 = Gtk.Label(_('strusbexcludephone'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (17, 1)
		self.switchBlacklistPUSB = Gtk.Switch()
		if self.check_autostart_USBSuspend(self.switchUSBSuspend) == False:
			self.switchBlacklistPUSB.set_active(False)
			self.switchBlacklistPUSB.set_sensitive(False)
		else:
			self.switchBlacklistPUSB.set_active(self.check_autostart_BlacklistPUSB(self.switchBlacklistPUSB))
			self.switchBlacklistPUSB.set_sensitive(True)
		table3.attach(self.switchBlacklistPUSB, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1'''
		# (18, 0)
		label33 = Gtk.Label(_('strusbexcludeprinter'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (18, 1)
		self.switchBlacklistPrintUSB = Gtk.Switch()
		if self.check_autostart_USBSuspend(self.switchUSBSuspend) == False:
			self.switchBlacklistPrintUSB.set_active(False)
			self.switchBlacklistPrintUSB.set_sensitive(False)
		else:
			self.switchBlacklistPrintUSB.set_active(self.check_autostart_BlacklistPrintUSB(self.switchBlacklistPrintUSB))
			self.switchBlacklistPrintUSB.set_sensitive(True)
		table3.attach(self.switchBlacklistPrintUSB, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (19, 0)
		label33 = Gtk.Label(_('strusbexcludeethernet'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (19, 1)
		self.switchBlacklistWWANUSB = Gtk.Switch()
		if self.check_autostart_USBSuspend(self.switchUSBSuspend) == False:
			self.switchBlacklistWWANUSB.set_active(False)
			self.switchBlacklistWWANUSB.set_sensitive(False)
		else:
			self.switchBlacklistWWANUSB.set_active(self.check_autostart_BlacklistWWANUSB(self.switchBlacklistWWANUSB))
			self.switchBlacklistWWANUSB.set_sensitive(True)
		table3.attach(self.switchBlacklistWWANUSB, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (20, 0)
		label33 = Gtk.Label(_('strusbautosuspenddisshutdown'))
		label33.set_alignment(0, 0.5)
		table3.attach(label33, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (20, 1)
		self.switchShutdownSuspendUSB = Gtk.Switch()
		if self.check_autostart_USBSuspend(self.switchUSBSuspend) == False:
			self.switchShutdownSuspendUSB.set_active(False)
			self.switchShutdownSuspendUSB.set_sensitive(False)
		else:
			self.switchShutdownSuspendUSB.set_active(self.check_autostart_ShutdownSuspendUSB(self.switchShutdownSuspendUSB))
			self.switchShutdownSuspendUSB.set_sensitive(True)
		table3.attach(self.switchShutdownSuspendUSB, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# ***************************************************************
		# -------------------------------- EQUILIBRADO --------------------------------
		pos1 = 0
		pos2 = 1
		# (0, 0)
		label44 = Gtk.Label('')
		label44.set_markup('<big><b>'+ (_('strtitlebatparams')) +'</b></big>')
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 2, pos1, pos2, xpadding=60, ypadding=8)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (1, 0)
		table_icon = Gtk.Table(2, 1, False)
		table4.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label44 = Gtk.Label(_('strlimitcpu'))
		label44.set_alignment(0, 0.5)
		table_icon.attach(label44, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/warning.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strlimitcputooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (1, 1)
		store = Gtk.ListStore(int, str)
		store.append([1, (_('strmaximumlimitcpu'))])
		store.append([2, (_('strmediumlimitcpu'))])
		store.append([3, (_('strnonelimitcpu'))])
		self.comboBoxLimitCPU2 = Gtk.ComboBox.new_with_model_and_entry(store)
		self.comboBoxLimitCPU2.set_entry_text_column(1)
		self.comboBoxLimitCPU2.set_active(self.check_autostart_comboBoxLimitCPU2(self.comboBoxLimitCPU2))
		table4.attach(self.comboBoxLimitCPU2, 1, 2, pos1, pos2,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (2, 0)
		governorCompatible, governor_name = governorIsCompatible()
		if governorCompatible == True:
			
			label44 = Gtk.Label(_('strgovernorcpu'))
			label44.set_alignment(0, 0.5)
			table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
			# (2, 1)
			store = Gtk.ListStore(int, str)
			if governor_name == 'intel_pstate':
				store.append([1, 'powersave'])
				store.append([2, 'performance'])
			elif governor_name == 'acpi-cpufreq':
				store.append([1, 'ondemand'])
				store.append([2, 'schedutil'])
				store.append([3, 'powersave'])
				store.append([4, 'performance'])
				store.append([5, 'conservative'])
			self.comboBoxGovernor2 = Gtk.ComboBox.new_with_model_and_entry(store)
			self.comboBoxGovernor2.set_entry_text_column(1)
			self.comboBoxGovernor2.set_active(self.check_autostart_Governor2(self.comboBoxGovernor2, governor_name))
			table4.attach(self.comboBoxGovernor2, 1, 2, pos1, pos2,
				xpadding=0,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)
			
			pos1 = pos1 + 1
			pos2 = pos2 + 1
		# (3, 0)
		label44 = Gtk.Label(_('strgraphicssaving'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (3, 1)
		self.switchGraphics2 = Gtk.Switch()
		self.switchGraphics2.set_active(self.check_autostart_switchGraphics2(self.switchGraphics2))
		table4.attach(self.switchGraphics2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (4, 0)
		table_icon = Gtk.Table(2, 1, False)
		table4.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label44 = Gtk.Label(_('strsoundsaving'))
		label44.set_alignment(0, 0.5)
		table_icon.attach(label44, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strsoundtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (4, 1)
		self.switchSound2 = Gtk.Switch()
		self.switchSound2.set_active(self.check_autostart_switchSound2(self.switchSound2))
		table4.attach(self.switchSound2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (5, 0)
		table_icon = Gtk.Table(2, 1, False)
		table4.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label44 = Gtk.Label(_('strwifisaving'))
		label44.set_alignment(0, 0.5)
		table_icon.attach(label44, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strwifisavingtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (5, 1)
		self.switchWifiPower2 = Gtk.Switch()
		self.switchWifiPower2.set_active(self.check_autostart_switchWifiPower2(self.switchWifiPower2))
		table4.attach(self.switchWifiPower2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (6, 0)
		label44 = Gtk.Label(_('strbluetoothniu'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (6, 1)
		self.switchBluetoothNIU2 = Gtk.Switch()
		self.switchBluetoothNIU2.set_active(self.check_autostart_switchBluetoothNIU2(self.switchBluetoothNIU2))
		table4.attach(self.switchBluetoothNIU2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (7, 0)
		label44 = Gtk.Label(_('strwifiniu'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (7, 1)
		self.switchWifiNIU2 = Gtk.Switch()
		self.switchWifiNIU2.set_active(self.check_autostart_switchWifiNIU2(self.switchWifiNIU2))
		table4.attach(self.switchWifiNIU2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (8, 0)
		label44 = Gtk.Label('')
		label44.set_markup('<big><b>'+ (_('strpersistentparams')) +'</b></big>')
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (9, 0)
		table_icon = Gtk.Table(2, 1, False)
		table4.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label44 = Gtk.Label(_('strbrightness'))
		label44.set_alignment(0, 0.5)
		table_icon.attach(label44, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strbirghtnesstooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (9, 1)
		self.scaleBrightness2 = Gtk.Scale()
		self.scaleBrightness2.set_size_request(200, 10)
		equilibradoBrightness = self.check_equilibradoBrightness()
		self.scaleBrightness2.set_adjustment(Gtk.Adjustment.new(int(equilibradoBrightness), 10, 100, 5, 5, 0))
		self.scaleBrightness2.set_digits(0)
		self.scaleBrightness2.set_hexpand(True)
		table4.attach(self.scaleBrightness2, 1, 2, pos1, pos2,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1

		if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
			# (10, 0)
			label44 = Gtk.Label(_('strdisanimations'))
			label44.set_alignment(0, 0.5)
			table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
			# (10, 1)
			self.switchAnimations2 = Gtk.Switch()
			self.switchAnimations2.set_active(self.check_autostart_switchAnimations2(self.switchAnimations2))
			table4.attach(self.switchAnimations2, 1, 2, pos1, pos2,
				xpadding=60,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)
			
			pos1 = pos1 + 1
			pos2 = pos2 + 1
		# (11, 0)
		label44 = Gtk.Label(_("strbluetoothdbos"))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (11, 1)
		self.switchBluetoothOS2 = Gtk.Switch()
		self.switchBluetoothOS2.set_active(self.check_autostart_switchBluetoothOS2(self.switchBluetoothOS2))
		table4.attach(self.switchBluetoothOS2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (12, 0)
		label44 = Gtk.Label(_("strwifidbos"))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (12, 1)
		self.switchWifiOS2 = Gtk.Switch()
		self.switchWifiOS2.set_active(self.check_autostart_switchWifiOS2(self.switchWifiOS2))
		table4.attach(self.switchWifiOS2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (13, 0)
		label44 = Gtk.Label(_('strwifionlanconn'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (13, 1)
		self.switchWifiDisableLAN2 = Gtk.Switch()
		self.switchWifiDisableLAN2.set_active(self.check_autostart_switchDisableLAN2(self.switchWifiDisableLAN2))
		table4.attach(self.switchWifiDisableLAN2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		
		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (14, 0)
		table_icon = Gtk.Table(2, 1, False)
		table4.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label44 = Gtk.Label(_('strautosuspendusb'))
		label44.set_alignment(0, 0.5)
		table_icon.attach(label44, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strautosuspendusbtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK)
		# (14, 1)
		self.switchUSBSuspend2 = Gtk.Switch()
		self.switchUSBSuspend2.set_active(self.check_autostart_USBSuspend2(self.switchUSBSuspend2))
		self.switchUSBSuspend2.connect("notify::active", self.on_switchUSBSuspend2_change)
		table4.attach(self.switchUSBSuspend2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (15, 0)
		table_icon = Gtk.Table(2, 1, False)
		table4.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label44 = Gtk.Label(_('strexcludedusbids'))
		label44.set_alignment(0, 0.5)
		table_icon.attach(label44, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		#Se leen los diferentes USB que hay disponibles y se almacenan en un archivo temporalmente
		os.system('lsusb | grep ID >> '+ user +'/.config/slimbookbattery/usbidlist')
		USBIDsList = ''
		#Se lee el archivo temporal que se ha creado y se va sacando para que solo nos muestre el ID junto con el nombre del USB
		f = open(user +'/.config/slimbookbattery/usbidlist', 'r')
		line = f.readline()
		while line:
			lineaActual = line
			#Saca la posición del ID en la linea
			IDPos = lineaActual.find("ID")
			#Saca la última posición de la linea
			longitud = len(lineaActual) - 1
			#Una vez teniendo estas 2 posiciones ya tenemos el ID junto con el nombre del USB y se concatena al string USBIDsList
			USBIDsList = USBIDsList + lineaActual[IDPos:longitud] +'\n'
			line = f.readline()
		f.close()
		#Se elimina el archivo temporal
		os.system('rm '+ user +'/.config/slimbookbattery/usbidlist')
		#En este tooltip 
		icon.set_tooltip_text((_('strexcludedusbtooltip.')) +'\n\n'+USBIDsList)
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (15, 1)
		self.entryBlacklistUSBIDs2 = Gtk.Entry()
		if self.check_autostart_USBSuspend2(self.switchUSBSuspend2) == False:
			self.entryBlacklistUSBIDs2.set_text('')
			self.entryBlacklistUSBIDs2.set_sensitive(False)
		else:
			self.entryBlacklistUSBIDs2.set_text(str(self.check_autostart_BlacklistUSBIDs2(self.entryBlacklistUSBIDs2)))
			self.entryBlacklistUSBIDs2.set_sensitive(True)
		table4.attach(self.entryBlacklistUSBIDs2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (16, 0)
		label44 = Gtk.Label(_('strusbexcludebluetooth'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (16, 1)
		self.switchBlacklistBUSB2 = Gtk.Switch()
		if self.check_autostart_USBSuspend2(self.switchUSBSuspend2) == False:
			self.switchBlacklistBUSB2.set_active(False)
			self.switchBlacklistBUSB2.set_sensitive(False)
		else:
			self.switchBlacklistBUSB2.set_active(self.check_autostart_BlacklistBUSB2(self.switchBlacklistBUSB2))
			self.switchBlacklistBUSB2.set_sensitive(True)
		table4.attach(self.switchBlacklistBUSB2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		'''# (17, 0)
		label44 = Gtk.Label(_('strusbexcludephone'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (17, 1)
		self.switchBlacklistPUSB2 = Gtk.Switch()
		if self.check_autostart_USBSuspend2(self.switchUSBSuspend2) == False:
			self.switchBlacklistPUSB2.set_active(False)
			self.switchBlacklistPUSB2.set_sensitive(False)
		else:
			self.switchBlacklistPUSB2.set_active(self.check_autostart_BlacklistPUSB2(self.switchBlacklistPUSB2))
			self.switchBlacklistPUSB2.set_sensitive(True)
		table4.attach(self.switchBlacklistPUSB2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1'''
		# (18, 0)
		label44 = Gtk.Label(_('strusbexcludeprinter'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (18, 1)
		self.switchBlacklistPrintUSB2 = Gtk.Switch()
		if self.check_autostart_USBSuspend2(self.switchUSBSuspend2) == False:
			self.switchBlacklistPrintUSB2.set_active(False)
			self.switchBlacklistPrintUSB2.set_sensitive(False)
		else:
			self.switchBlacklistPrintUSB2.set_active(self.check_autostart_BlacklistPrintUSB2(self.switchBlacklistPrintUSB2))
			self.switchBlacklistPrintUSB2.set_sensitive(True)
		table4.attach(self.switchBlacklistPrintUSB2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (19, 0)
		label44 = Gtk.Label(_('strusbexcludeethernet'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (19, 1)
		self.switchBlacklistWWANUSB2 = Gtk.Switch()
		if self.check_autostart_USBSuspend2(self.switchUSBSuspend2) == False:
			self.switchBlacklistWWANUSB2.set_active(False)
			self.switchBlacklistWWANUSB2.set_sensitive(False)
		else:
			self.switchBlacklistWWANUSB2.set_active(self.check_autostart_BlacklistWWANUSB2(self.switchBlacklistWWANUSB2))
			self.switchBlacklistWWANUSB2.set_sensitive(True)
		table4.attach(self.switchBlacklistWWANUSB2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (20, 0)
		label44 = Gtk.Label(_('strusbautosuspenddisshutdown'))
		label44.set_alignment(0, 0.5)
		table4.attach(label44, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (20, 1)
		self.switchShutdownSuspendUSB2 = Gtk.Switch()
		if self.check_autostart_USBSuspend2(self.switchUSBSuspend2) == False:
			self.switchShutdownSuspendUSB2.set_active(False)
			self.switchShutdownSuspendUSB2.set_sensitive(False)
		else:
			self.switchShutdownSuspendUSB2.set_active(self.check_autostart_ShutdownSuspendUSB2(self.switchShutdownSuspendUSB2))
			self.switchShutdownSuspendUSB2.set_sensitive(True)
		table4.attach(self.switchShutdownSuspendUSB2, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# ***************************************************************
		# -------------------------------- MÁXIMO RENDIMIENTO --------------------------------
		pos1 = 0
		pos2 = 1
		# (0, 0)
		label55 = Gtk.Label('')
		label55.set_markup('<big><b>'+ (_('strtitlebatparams')) +'</b></big>')
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 2, pos1, pos2, xpadding=60, ypadding=8)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (1, 0)
		table_icon = Gtk.Table(2, 1, False)
		table5.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label55 = Gtk.Label(_('strlimitcpu'))
		label55.set_alignment(0, 0.5)
		table_icon.attach(label55, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/warning.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strlimitcputooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (1, 1)
		store = Gtk.ListStore(int, str)
		store.append([1, (_('strmaximumlimitcpu'))])
		store.append([2, (_('strmediumlimitcpu'))])
		store.append([3, (_('strnonelimitcpu'))])
		self.comboBoxLimitCPU3 = Gtk.ComboBox.new_with_model_and_entry(store)
		self.comboBoxLimitCPU3.set_entry_text_column(1)
		self.comboBoxLimitCPU3.set_active(self.check_autostart_comboBoxLimitCPU3(self.comboBoxLimitCPU3))
		table5.attach(self.comboBoxLimitCPU3, 1, 2, pos1, pos2,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (2, 0)
		governorCompatible, governor_name = governorIsCompatible()
		if governorCompatible == True:
			label55 = Gtk.Label(_('strgovernorcpu'))
			label55.set_alignment(0, 0.5)
			table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
			# (2, 1)
			store = Gtk.ListStore(int, str)
			if (os.path.isdir('/sys/devices/system/cpu/intel_pstate')):
				store.append([1, 'powersave'])
				store.append([2, 'performance'])
			elif (os.path.isdir('/sys/devices/system/cpu/acpi-cpufreq')):
				store.append([1, 'ondemand'])
				store.append([2, 'schedutil'])
				store.append([3, 'powersave'])
				store.append([4, 'performance'])
				store.append([5, 'conservative'])
			self.comboBoxGovernor3 = Gtk.ComboBox.new_with_model_and_entry(store)
			self.comboBoxGovernor3.set_entry_text_column(1)
			self.comboBoxGovernor3.set_active(self.check_autostart_Governor3(self.comboBoxGovernor3, governor_name))
			table5.attach(self.comboBoxGovernor3, 1, 2, pos1, pos2,
				xpadding=0,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)

			pos1 = pos1 + 1
			pos2 = pos2 + 1
		# (3, 0)
		label55 = Gtk.Label(_('strgraphicssaving'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (3, 1)
		self.switchGraphics3 = Gtk.Switch()
		self.switchGraphics3.set_sensitive(False)
		table5.attach(self.switchGraphics3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (4, 0)
		table_icon = Gtk.Table(2, 1, False)
		table5.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label55 = Gtk.Label(_('strsoundsaving'))
		label55.set_alignment(0, 0.5)
		table_icon.attach(label55, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strsoundtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (4, 1)
		self.switchSound3 = Gtk.Switch()
		self.switchSound3.set_active(self.check_autostart_switchSound3(self.switchSound3))
		table5.attach(self.switchSound3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (5, 0)
		table_icon = Gtk.Table(2, 1, False)
		table5.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label55 = Gtk.Label(_('strwifisaving'))
		label55.set_alignment(0, 0.5)
		table_icon.attach(label55, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strwifisavingtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (5, 1)
		self.switchWifiPower3 = Gtk.Switch()
		self.switchWifiPower3.set_active(self.check_autostart_switchWifiPower3(self.switchWifiPower3))
		table5.attach(self.switchWifiPower3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (6, 0)
		label55 = Gtk.Label(_('strbluetoothniu'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (6, 1)
		self.switchBluetoothNIU3 = Gtk.Switch()
		self.switchBluetoothNIU3.set_active(self.check_autostart_switchBluetoothNIU3(self.switchBluetoothNIU3))
		table5.attach(self.switchBluetoothNIU3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (7, 0)
		label55 = Gtk.Label(_('strwifiniu'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (7, 1)
		self.switchWifiNIU3 = Gtk.Switch()
		self.switchWifiNIU3.set_active(self.check_autostart_switchWifiNIU3(self.switchWifiNIU3))
		table5.attach(self.switchWifiNIU3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (8, 0)
		label55 = Gtk.Label('')
		label55.set_markup('<big><b>'+ (_('strpersistentparams')) +'</b></big>')
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (9, 0)
		table_icon = Gtk.Table(2, 1, False)
		table5.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label55 = Gtk.Label(_('strbrightness'))
		label55.set_alignment(0, 0.5)
		table_icon.attach(label55, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strbirghtnesstooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (9, 1)
		self.scaleBrightness3 = Gtk.Scale()
		self.scaleBrightness3.set_size_request(200, 10)
		maxrendimientoBrightness = self.check_maxrendimientoBrightness()
		self.scaleBrightness3.set_adjustment(Gtk.Adjustment.new(int(maxrendimientoBrightness), 10, 100, 5, 5, 0))
		self.scaleBrightness3.set_digits(0)
		self.scaleBrightness3.set_hexpand(True)
		table5.attach(self.scaleBrightness3, 1, 2, pos1, pos2,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1

		if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
			# (10, 0)
			label55 = Gtk.Label(_('strdisanimations'))
			label55.set_alignment(0, 0.5)
			table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
			# (10, 1)
			self.switchAnimations3 = Gtk.Switch()
			self.switchAnimations3.set_active(self.check_autostart_switchAnimations3(self.switchAnimations3))
			table5.attach(self.switchAnimations3, 1, 2, pos1, pos2,
				xpadding=60,
				ypadding=5,
				xoptions=Gtk.AttachOptions.SHRINK,
				yoptions=Gtk.AttachOptions.SHRINK)
			
			pos1 = pos1 + 1
			pos2 = pos2 + 1
		# (10, 0)
		label55 = Gtk.Label(_("strbluetoothdbos"))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (10, 1)
		self.switchBluetoothOS3 = Gtk.Switch()
		self.switchBluetoothOS3.set_active(self.check_autostart_switchBluetoothOS3(self.switchBluetoothOS3))
		table5.attach(self.switchBluetoothOS3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (11, 0)
		label55 = Gtk.Label(_("strwifidbos"))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (11, 1)
		self.switchWifiOS3 = Gtk.Switch()
		self.switchWifiOS3.set_active(self.check_autostart_switchWifiOS3(self.switchWifiOS3))
		table5.attach(self.switchWifiOS3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (12, 0)
		label55 = Gtk.Label(_('strwifionlanconn'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (12, 1)
		self.switchWifiDisableLAN3 = Gtk.Switch()
		self.switchWifiDisableLAN3.set_active(self.check_autostart_switchDisableLAN3(self.switchWifiDisableLAN3))
		table5.attach(self.switchWifiDisableLAN3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (13, 0)
		table_icon = Gtk.Table(2, 1, False)
		table5.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label55 = Gtk.Label(_('strautosuspendusb'))
		label55.set_alignment(0, 0.5)
		table_icon.attach(label55, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strautosuspendusbtooltip'))
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (13, 1)
		self.switchUSBSuspend3 = Gtk.Switch()
		self.switchUSBSuspend3.set_active(self.check_autostart_USBSuspend3(self.switchUSBSuspend3))
		self.switchUSBSuspend3.connect("notify::active", self.on_switchUSBSuspend3_change)
		table5.attach(self.switchUSBSuspend3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (14, 0)
		table_icon = Gtk.Table(2, 1, False)
		table5.attach(table_icon, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		label55 = Gtk.Label(_('strexcludedusbids'))
		label55.set_alignment(0, 0.5)
		table_icon.attach(label55, 0, 1, 0, 1,
			xpadding=0,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/help.png'
		icon.set_from_file(icon_path)
		#Se leen los diferentes USB que hay disponibles y se almacenan en un archivo temporalmente
		os.system('lsusb | grep ID >> '+ user +'/.config/slimbookbattery/usbidlist')
		USBIDsList = ''
		#Se lee el archivo temporal que se ha creado y se va sacando para que solo nos muestre el ID junto con el nombre del USB
		f = open(user +'/.config/slimbookbattery/usbidlist', 'r')
		line = f.readline()
		while line:
			lineaActual = line
			#Saca la posición del ID en la linea
			IDPos = lineaActual.find("ID")
			#Saca la última posición de la linea
			longitud = len(lineaActual) - 1
			#Una vez teniendo estas 2 posiciones ya tenemos el ID junto con el nombre del USB y se concatena al string USBIDsList
			USBIDsList = USBIDsList + lineaActual[IDPos:longitud] +'\n'
			line = f.readline()
		f.close()
		#Se elimina el archivo temporal
		os.system('rm '+ user +'/.config/slimbookbattery/usbidlist')
		#En este tooltip 
		icon.set_tooltip_text((_('strexcludedusbtooltip.')) +'\n\n'+USBIDsList)
		icon.set_alignment(0, 0.5)
		table_icon.attach(icon, 1, 2, 0, 1, 
			xpadding=10,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (14, 1)
		self.entryBlacklistUSBIDs3 = Gtk.Entry()
		if self.check_autostart_USBSuspend3(self.switchUSBSuspend3) == False:
			self.entryBlacklistUSBIDs3.set_text('')
			self.entryBlacklistUSBIDs3.set_sensitive(False)
		else:
			self.entryBlacklistUSBIDs3.set_text(str(self.check_autostart_BlacklistUSBIDs3(self.entryBlacklistUSBIDs3)))
			self.entryBlacklistUSBIDs3.set_sensitive(True)
		table5.attach(self.entryBlacklistUSBIDs3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (15, 0)
		label55 = Gtk.Label(_('strusbexcludebluetooth'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (15, 1)
		self.switchBlacklistBUSB3 = Gtk.Switch()
		if self.check_autostart_USBSuspend3(self.switchUSBSuspend3) == False:
			self.switchBlacklistBUSB3.set_active(False)
			self.switchBlacklistBUSB3.set_sensitive(False)
		else:
			self.switchBlacklistBUSB3.set_active(self.check_autostart_BlacklistBUSB3(self.switchBlacklistBUSB3))
			self.switchBlacklistBUSB3.set_sensitive(True)
		table5.attach(self.switchBlacklistBUSB3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		'''# (16, 0)
		label55 = Gtk.Label(_('strusbexcludephone'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (16, 1)
		self.switchBlacklistPUSB3 = Gtk.Switch()
		if self.check_autostart_USBSuspend3(self.switchUSBSuspend3) == False:
			self.switchBlacklistPUSB3.set_active(False)
			self.switchBlacklistPUSB3.set_sensitive(False)
		else:
			self.switchBlacklistPUSB3.set_active(self.check_autostart_BlacklistPUSB3(self.switchBlacklistPUSB3))
			self.switchBlacklistPUSB3.set_sensitive(True)
		table5.attach(self.switchBlacklistPUSB3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1'''
		# (17, 0)
		label55 = Gtk.Label(_('strusbexcludeprinter'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (17, 1)
		self.switchBlacklistPrintUSB3 = Gtk.Switch()
		if self.check_autostart_USBSuspend3(self.switchUSBSuspend3) == False:
			self.switchBlacklistPrintUSB3.set_active(False)
			self.switchBlacklistPrintUSB3.set_sensitive(False)
		else:
			self.switchBlacklistPrintUSB3.set_active(self.check_autostart_BlacklistPrintUSB3(self.switchBlacklistPrintUSB3))
			self.switchBlacklistPrintUSB3.set_sensitive(True)
		table5.attach(self.switchBlacklistPrintUSB3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (18, 0)
		label55 = Gtk.Label(_('strusbexcludeethernet'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (18, 1)
		self.switchBlacklistWWANUSB3 = Gtk.Switch()
		if self.check_autostart_USBSuspend3(self.switchUSBSuspend3) == False:
			self.switchBlacklistWWANUSB3.set_active(False)
			self.switchBlacklistWWANUSB3.set_sensitive(False)
		else:
			self.switchBlacklistWWANUSB3.set_active(self.check_autostart_BlacklistWWANUSB3(self.switchBlacklistWWANUSB3))
			self.switchBlacklistWWANUSB3.set_sensitive(True)
		table5.attach(self.switchBlacklistWWANUSB3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)

		pos1 = pos1 + 1
		pos2 = pos2 + 1
		# (19, 0)
		label55 = Gtk.Label(_('strusbautosuspenddisshutdown'))
		label55.set_alignment(0, 0.5)
		table5.attach(label55, 0, 1, pos1, pos2, xpadding=60, ypadding=5)
		# (19, 1)
		self.switchShutdownSuspendUSB3 = Gtk.Switch()
		if self.check_autostart_USBSuspend3(self.switchUSBSuspend3) == False:
			self.switchShutdownSuspendUSB3.set_active(False)
			self.switchShutdownSuspendUSB3.set_sensitive(False)
		else:
			self.switchShutdownSuspendUSB3.set_active(self.check_autostart_ShutdownSuspendUSB3(self.switchShutdownSuspendUSB3))
			self.switchShutdownSuspendUSB3.set_sensitive(True)
		table5.attach(self.switchShutdownSuspendUSB3, 1, 2, pos1, pos2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# ***************************************************************
		# -------------------------------- CYCLES --------------------------------
		# (0, 0)
		label22 = Gtk.Label(_('strswitchcyclealerts'))
		label22.set_alignment(0, 0.5)
		table2.attach(label22, 0, 1, 0, 1, xpadding=60, ypadding=5)
		# (0, 1)
		self.switchAlerts = Gtk.Switch()
		self.switchAlerts.set_active(self.check_autostart_switchAlerts(self.switchAlerts))
		table2.attach(self.switchAlerts, 1, 2, 0, 1,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (1, 0)
		label22 = Gtk.Label(_('strmaxbatval'))
		label22.set_alignment(0, 0.5)
		table2.attach(label22, 0, 1, 1, 2, xpadding=60, ypadding=5)
		# (1, 1)
		self.scaleMaxBatVal = Gtk.Scale()
		self.scaleMaxBatVal.set_size_request(200, 10)
		max_value = self.check_value_max()
		self.scaleMaxBatVal.set_adjustment(Gtk.Adjustment.new(int(max_value), 50, 100, 5, 5, 0))
		self.scaleMaxBatVal.set_digits(0)
		self.scaleMaxBatVal.set_hexpand(True)
		table2.attach(self.scaleMaxBatVal, 1, 2, 1, 2,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.FILL,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (2, 0)
		label22 = Gtk.Label(_('strminbatval'))
		label22.set_alignment(0, 0.5)
		table2.attach(label22, 0, 1, 2, 3, xpadding=60, ypadding=5)
		# (2, 1)
		self.scaleMinBatVal = Gtk.Scale()
		self.scaleMinBatVal.set_size_request(200, 10)
		min_value = self.check_value_min()
		self.scaleMinBatVal.set_adjustment(Gtk.Adjustment.new(int(min_value), 0, 49, 5, 5, 0))
		self.scaleMinBatVal.set_digits(0)
		self.scaleMinBatVal.set_hexpand(True)
		table2.attach(self.scaleMinBatVal, 1, 2, 2, 3,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.FILL,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (3, 0)
		label22 = Gtk.Label(_('strnumoftimes'))
		label22.set_alignment(0, 0.5)
		table2.attach(label22, 0, 1, 3, 4, xpadding=60, ypadding=5)
		# (3, 1)
		self.scaleNumTimes = Gtk.Scale()
		self.scaleNumTimes.set_size_request(200, 10)
		max_vaule = self.check_times_max()
		self.scaleNumTimes.set_adjustment(Gtk.Adjustment.new(int(max_vaule), 0, 10, 5, 5, 0))
		self.scaleNumTimes.set_digits(0)
		self.scaleNumTimes.set_hexpand(True)
		table2.attach(self.scaleNumTimes, 1, 2, 3, 4,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.FILL,
			yoptions=Gtk.AttachOptions.SHRINK)
		# (4, 0)
		label22 = Gtk.Label(_('strtimebwnwarnings'))
		label22.set_alignment(0, 0.5)
		table2.attach(label22, 0, 1, 4, 5, xpadding=60, ypadding=5)
		# (4, 1)
		self.scaleTimeWarnings = Gtk.Scale()
		self.scaleTimeWarnings.set_size_request(200, 10)
		min_vaule = self.check_times_min()
		self.scaleTimeWarnings.set_adjustment(Gtk.Adjustment.new(int(min_vaule), 0, 300, 5, 5, 0))
		self.scaleTimeWarnings.set_digits(0)
		self.scaleTimeWarnings.set_hexpand(True)
		table2.attach(self.scaleTimeWarnings, 1, 2, 4, 5,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.FILL,
			yoptions=Gtk.AttachOptions.SHRINK)
		'''
		# (5, 0)
		self.buttonRestCycles = Gtk.Button(label='Restore to default values')
		self.buttonRestCycles.connect("clicked", self.on_buttonRestCycles_clicked)
		table2.attach(self.buttonRestCycles, 0, 1, 5, 6,
			xpadding=60,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		'''
		# ***************************************************************
		# -------------------------------- BATTERY INFO --------------------------------
		# GET DATA
		data = self.read_bat()
		# (0, 0)
		label66 = Gtk.Label(' ')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 0, 1, 0, 1, xpadding=5, ypadding=5)
		# (0, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strbatdevice'))+ '</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 0, 1, xpadding=5, ypadding=5)
		# (0, 2)
		label66 = Gtk.Label(data[0])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 0, 1, xpadding=5, ypadding=5)
		# (1, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strmanufacturer')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 1, 2, xpadding=5, ypadding=5)
		# (1, 2)
		label66 = Gtk.Label(data[1])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 1, 2, xpadding=5, ypadding=5)
		# (2, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strbatmodel')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 2, 3, xpadding=5, ypadding=5)
		# (2, 2)
		label66 = Gtk.Label(data[2])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 2, 3, xpadding=5, ypadding=5)
		# (3, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strtechnology')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 3, 4, xpadding=5, ypadding=5)
		# (3, 2)
		label66 = Gtk.Label(data[3])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 3, 4, xpadding=5, ypadding=5)
		# (4, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strremainbat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 4, 5, xpadding=5, ypadding=5)
		# (4, 2)
		label66 = Gtk.Label(data[4])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 4, 5, xpadding=5, ypadding=5)
		# (5, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strmaxcapacity')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 5, 6, xpadding=5, ypadding=5)
		# (5, 2)
		label66 = Gtk.Label(data[5])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 5, 6, xpadding=5, ypadding=5)
		# (6, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strstatusbat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 6, 7, xpadding=5, ypadding=5)
		# (6, 2)
		label66 = Gtk.Label(data[6])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 6, 7, xpadding=5, ypadding=5)
		# (7, 1)
		if data[6].lower() == 'charging':
			label66 = Gtk.Label('')
			label66.set_markup('<b>'+ (_('strtimetofullbat')) +'</b>')
			label66.set_alignment(0, 0.5)
			table6.attach(label66, 1, 2, 7, 8, xpadding=5, ypadding=5)
		elif data[6].lower() == 'discharging':
			label66 = Gtk.Label('')
			label66.set_markup('<b>'+ (_('strtimetoemptybat')) +'</b>')
			label66.set_alignment(0, 0.5)
			table6.attach(label66, 1, 2, 7, 8, xpadding=5, ypadding=5)
		elif data[6].lower() == 'fully-charged':
			label66 = Gtk.Label('')
			label66.set_markup('<b>'+ (_('strtimetofullbat')) +'</b>')
			label66.set_alignment(0, 0.5)
			table6.attach(label66, 1, 2, 7, 8, xpadding=5, ypadding=5)
		else:
			label66 = Gtk.Label('')
			label66.set_markup('<b>'+ (_('strtimetofullemptybat')) +'</b>')
			label66.set_alignment(0, 0.5)
			table6.attach(label66, 1, 2, 7, 8, xpadding=5, ypadding=5)
		# (7, 2)
		label66 = Gtk.Label(data[7])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 7, 8, xpadding=5, ypadding=5)
		# (8, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strrechargeablebat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 8, 9, xpadding=5, ypadding=5)
		# (8, 2)
		label66 = Gtk.Label(data[8])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 8, 9, xpadding=5, ypadding=5)
		# (9, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strpowersupplybat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 9, 10, xpadding=5, ypadding=5)
		# (9, 2)
		label66 = Gtk.Label(data[9])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 9, 10, xpadding=5, ypadding=5)
		# (10, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strenergyfullbat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 10, 11, xpadding=5, ypadding=5)
		# (10, 2)
		label66 = Gtk.Label(data[10])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 10, 11, xpadding=5, ypadding=5)
		# (11, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strenergyfulldesignbat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 11, 12, xpadding=5, ypadding=5)
		# (11, 2)
		label66 = Gtk.Label(data[11])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 11, 12, xpadding=5, ypadding=5)
		# (12, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strenergyratebat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 12, 13, xpadding=5, ypadding=5)
		# (12, 2)
		label66 = Gtk.Label(data[12])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 12, 13, xpadding=5, ypadding=5)
		# (13, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strvoltagebat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 13, 14, xpadding=5, ypadding=5)
		# (13, 2)
		label66 = Gtk.Label(data[13])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 13, 14, xpadding=5, ypadding=5)
		# (14, 1)
		label66 = Gtk.Label('')
		label66.set_markup('<b>'+ (_('strlastupdatebat')) +'</b>')
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 1, 2, 14, 15, xpadding=5, ypadding=5)
		# (14, 2)
		label66 = Gtk.Label(data[14])
		label66.set_alignment(0, 0.5)
		table6.attach(label66, 2, 3, 14, 15, xpadding=5, ypadding=5)
		# ***************************************************************
		# -------------------------------- APPLICATION INFO --------------------------------
		# (0, 0)
		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/normal.png',
			width=100,
			height=100,
			preserve_aspect_ratio=True)
		iconApp = Gtk.Image.new_from_pixbuf(pixbuf)
		iconApp.set_alignment(0.5, 0)
		table7.attach(iconApp, 0, 1, 0, 1, xpadding=5, ypadding=5)
		# (1, 0)
		label77 = Gtk.Label('')
		label77.set_markup('<span font="20"><b>Slimbook Battery 3</b></span>')
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 1, 1, 2, xpadding=5, ypadding=5)
		# (2, 0)
		label77 = Gtk.Label('')
		label77.set_markup("<span>"+ (_("strslimbookbatdesc1")) +"\n"+ (_("strslimbookbatdesc2")) +"</span>")
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 1, 2, 3, xpadding=5, ypadding=5)
		# (3, 0)
		label77 = Gtk.Label('')
		label77.set_markup("<span>"+ (_("strslimbookbatthanks")) +"</span>")
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 1, 3, 4, xpadding=5, ypadding=5)
		# (4, 0)
		label77 = Gtk.Label('')
		label77.set_markup("<span>"+ (_("strslimbookbatsocialnetworks")) +"</span>")
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 1, 4, 5, xpadding=5, ypadding=5)
		# (5, 0)
		hbox = Gtk.HBox(spacing=5)
		table7.attach(hbox, 0, 1, 5, 6,
			xpadding=5,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/twitter.png',
			width=25,
			height=25,
			preserve_aspect_ratio=True)
		twitter = Gtk.Image.new_from_pixbuf(pixbuf)
		twitter.set_alignment(0.5, 0)
		hbox.pack_start(twitter, False, False, 0)
		label77 = Gtk.Label(' ')
		label77.set_markup("<span><b><a href='https://twitter.com/SlimbookEs'>@SlimbookEs</a></b>    </span>")
		label77.set_justify(Gtk.Justification.CENTER)
		hbox.pack_start(label77, False, False, 0)

		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/facebook.png',
			width=25,
			height=25,
			preserve_aspect_ratio=True)
		facebook = Gtk.Image.new_from_pixbuf(pixbuf)
		facebook.set_alignment(0.5, 0)
		hbox.pack_start(facebook, False, False, 0)
		label77 = Gtk.Label(' ')
		label77.set_markup("<span><b><a href='https://www.facebook.com/slimbook.es'>Slimbook</a></b>    </span>")
		label77.set_justify(Gtk.Justification.CENTER)
		hbox.pack_start(label77, False, False, 0)

		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/mastodon.png',
			width=25,
			height=25,
			preserve_aspect_ratio=True)
		mastodon = Gtk.Image.new_from_pixbuf(pixbuf)
		mastodon.set_alignment(0.5, 0)
		hbox.pack_start(mastodon, False, False, 0)
		label77 = Gtk.Label(' ')
		label77.set_markup("<span><b><a href='https://mastodon.social/@slimbook'>@Slimbook</a></b></span>")
		label77.set_justify(Gtk.Justification.CENTER)
		hbox.pack_start(label77, False, False, 0)
		# (6, 0)
		label77 = Gtk.Label()
		label77.set_markup("<span><b>"+ (_("stradvice1")) +"</b>"+ (_("stradvice2")) +"\n"+ (_("stradvice3")) +"</span>")
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 1, 6, 7, xpadding=5, ypadding=5)
		# (7, 0)
		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/logo.png',
			width=299,
			height=180,
			preserve_aspect_ratio=True)
		logo = Gtk.Image.new_from_pixbuf(pixbuf)
		logo.set_alignment(0.5, 0)
		table7.attach(logo, 0, 1, 7, 8, xpadding=5, ypadding=5)
		# (8, 0)
		label77 = Gtk.LinkButton('https://slimbook.es/', label=(_('strvisitwebsite')))
		label77.set_alignment(0.5, 0)
		table7.attach(label77, 0, 1, 8, 9, xpadding=5, ypadding=1)
		# (9, 0)
		label77 = Gtk.LinkButton((_('strurlwebsite')), label=(_('strvisittutorial')))
		label77.set_alignment(0.5, 0)
		table7.attach(label77, 0, 1, 9, 10, xpadding=5, ypadding=1)
		# (10, 0)
		label77 = Gtk.Label('')
		label77.set_markup("<span><b>"+ (_("straditionalinfo1")) +" </b>"+ (_("straditionalinfo2")) +"\n"+ (_("straditionalinfo3")) +"</span>")
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 1, 10, 11, xpadding=5, ypadding=5)
		# (11, 0)
		hbox = Gtk.HBox(spacing=5)
		table7.attach(hbox, 0, 1, 11, 12,
			xpadding=5,
			ypadding=5,
			xoptions=Gtk.AttachOptions.SHRINK,
			yoptions=Gtk.AttachOptions.SHRINK)
		label77 = Gtk.Label(' ')
		label77.set_markup("<span><b>"+ (_("strsendemail")) +"dev@slimbook.es</b></span>")
		label77.set_justify(Gtk.Justification.CENTER)
		hbox.pack_start(label77, False, False, 0)
		icon = Gtk.Image()
		icon_path = '/usr/share/slimbookbattery/images/copy.png'
		icon.set_from_file(icon_path)
		icon.set_tooltip_text(_('strcopyemail'))
		buttonCopyEmail = Gtk.Button()
		buttonCopyEmail.add(icon)
		buttonCopyEmail.connect("clicked", self.on_buttonCopyEmail_clicked)
		buttonCopyEmail.set_alignment(0.5, 0)
		hbox.pack_start(buttonCopyEmail, False, False, 0)
		# (12, 0)
		self.buttonReportFile = Gtk.Button(label=(_('strgeneratereport')))
		self.buttonReportFile.connect("clicked", self.on_buttonReportFile_clicked)
		table7.attach(self.buttonReportFile, 0, 1, 12, 13, xpadding=5, ypadding=5, xoptions=Gtk.AttachOptions.SHRINK, yoptions=Gtk.AttachOptions.SHRINK)
		# (13, 0)
		label77 = Gtk.Label('')
		label77.set_markup(_('strwarranty'))
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 2, 13, 14, xpadding=5, ypadding=5)
		# (13, 0)
		label77 = Gtk.Label('')
		label77.set_markup('<b>'+ (_('strlicense1')) +'</b>\n<span size="smaller"><b>'+ (_('strlicense2')) +'</b>'+ (_('strlicense3')) +'\n'+ (_('strlicense4')) +'</span>')
		label77.set_justify(Gtk.Justification.CENTER)
		table7.attach(label77, 0, 2, 14, 15, xpadding=5, ypadding=5)
		# (14, 0)
		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/cc.png',
			width=100,
			height=200,
			preserve_aspect_ratio=True)
		CCIcon = Gtk.Image.new_from_pixbuf(pixbuf)
		CCIcon.set_alignment(0.5, 0)
		table7.attach(CCIcon, 0, 2, 15, 16, xpadding=5, ypadding=5)
		#SHOW
		self.show_all()

	def read_bat(self):
		var = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '']

		if os.system("upower -i `upower -e | grep 'BAT'` | grep native-path") == 0:
			batDevice = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep native-path")
			batDevice = batDevice.split()
			batDevice = batDevice[1]
		else:
			batDevice = (_('strunknown'))
		var[0] = batDevice

		if os.system("upower -i `upower -e | grep 'BAT'` | grep vendor") == 0:
			manufacturer = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep vendor")
			manufacturer = manufacturer.split()
			manufacturer = manufacturer[1]
		else:
			manufacturer = (_('strunknown'))
		var[1] = manufacturer

		if os.system("upower -i `upower -e | grep 'BAT'` | grep model") == 0:
			model = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep model")
			model = model.split()
			model = model[1]
		else:
			model = (_('strunknown'))
		var[2] = model

		if os.system("upower -i `upower -e | grep 'BAT'` | grep technology") == 0:
			technology = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep technology")
			technology = technology.split()
			technology = technology[1]
		else:
			technology = (_('strunknown'))
		var[3] = technology.capitalize()

		if os.system("upower -i `upower -e | grep 'BAT'` | grep percentage") == 0:
			currentCharge = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep percentage")
			currentCharge = currentCharge.split()
			currentCharge = currentCharge[1]
		else:
			currentCharge = (_('strunknown'))
		var[4] = currentCharge

		if os.system("upower -i `upower -e | grep 'BAT'` | grep capacity") == 0:
			maxCapacity = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep capacity")
			maxCapacity = maxCapacity.split()
			maxCapacity = maxCapacity[1]
		else:
			maxCapacity = (_('strunknown'))
		var[5] = maxCapacity

		if os.system("upower -i `upower -e | grep 'BAT'` | grep state") == 0:
			status = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep state")
			status = status.split()
			status = status[1]
		else:
			status = (_('strunknown'))
		var[6] = status.capitalize()

		if status == 'discharging':
			if os.system("upower -i `upower -e | grep 'BAT'` | grep 'time to empty'") == 0:
				timeTo = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep 'time to empty'")
				timeTo = timeTo.split()
				timeTo = timeTo[3] + (_('strhours'))
			else:
				timeTo = (_('strunknown'))
		elif status == 'charging':
			if os.system("upower -i `upower -e | grep 'BAT'` | grep 'time to full'") == 0:
				timeTo = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep 'time to full'")
				timeTo = timeTo.split()
				timeTo = timeTo[3] + (_('strhours'))
			else:
				timeTo = (_('strunknown'))
		elif status == 'fully-charged':
			timeTo = (_('strfullychargedbat'))
		else:
			timeTo = (_('strunknown'))
		var[7] = timeTo

		if os.system("upower -i `upower -e | grep 'BAT'` | grep rechargeable") == 0:
			rechargeable = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep rechargeable")
			rechargeable = rechargeable.split()
			rechargeable = rechargeable[1]
		else:
			rechargeable = (_('strunknown'))
		var[8] = rechargeable.capitalize()

		if os.system("upower -i `upower -e | grep 'BAT'` | grep 'power supply'") == 0:
			powerSupply = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep 'power supply'")
			powerSupply = powerSupply.split()
			powerSupply = powerSupply[2]
		else:
			powerSupply = (_('strunknown'))
		var[9] = powerSupply.capitalize()

		if os.system("upower -i `upower -e | grep 'BAT'` | grep energy-full") == 0:
			chargeFull = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep energy-full")
			chargeFull = chargeFull.split()
			chargeFull = str(chargeFull[1]) + ' Wh'
		else:
			chargeFull = (_('strunknown'))
		var[10] = chargeFull

		if os.system("upower -i `upower -e | grep 'BAT'` | grep energy-full-design") == 0:
			chargeDesign = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep energy-full-design")
			chargeDesign = chargeDesign.split()
			chargeDesign = str(chargeDesign[1]) + ' Wh'
		else:
			chargeDesign = (_('strunknown'))
		var[11] = chargeDesign

		if os.system("upower -i `upower -e | grep 'BAT'` | grep energy-rate") == 0:
			chargeRate = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep energy-rate")
			chargeRate = chargeRate.split()
			chargeRate = str(chargeRate[1]) + ' Wh'
		else:
			chargeRate = (_('strunknown'))
		var[12] = chargeRate

		if os.system("upower -i `upower -e | grep 'BAT'` | grep voltage") == 0:
			voltage = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep voltage")
			voltage = voltage.split()
			voltage = str(voltage[1]) + ' V'
		else:
			voltage = (_('strunknown'))
		var[13] = voltage

		if os.system("upower -i `upower -e | grep 'BAT'` | grep updated") == 0:
			infoUpdated = subprocess.getoutput("upower -i `upower -e | grep 'BAT'` | grep updated")
			infoUpdated = infoUpdated.split()
			date = ''
			for i in range(len(infoUpdated)):
				if int(i) != 0:
					date = str(date) + str(infoUpdated[i]) + ' '
			infoUpdated = date
		else:
			infoUpdated = (_('strunknown'))
		var[14] = infoUpdated.capitalize()

		return var

	def on_buttonReportFile_clicked(self, buttonReportFile):
		#Se abrirá un dialogo para el usuario para que elija donde desea guardar el archivo del reporte que se va a generar
		saveDialog = Gtk.FileChooserDialog("Please select a folder to save the file", self, Gtk.FileChooserAction.SELECT_FOLDER, (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL, Gtk.STOCK_SAVE, Gtk.ResponseType.OK))
		response = saveDialog.run()
		if response == Gtk.ResponseType.OK:
			ruta = saveDialog.get_filename() + '/report_'+ time.strftime("%d-%m-%y_%H:%M") +'.txt'
			escritorio = subprocess.getoutput("echo $XDG_CURRENT_DESKTOP")
			if os.system("pkexec python3 /usr/share/slimbookbattery/slimbookbattery-report.pyc "+ ruta +' '+ escritorio +' '+ user) == 0:
				print(_('strprintreportfilecheck1'))
			else:
				print(_('strprintreportfilecheck2'))
		elif response == Gtk.ResponseType.CANCEL:
			print(_('strprintreportfilecheck3'))
		saveDialog.destroy()
	
	#Copia el correo eléctronico al portapapeles y muestra una notificación el sistema
	def on_buttonCopyEmail_clicked(self, buttonCopyEmail):
		self.clipboard = Gtk.Clipboard.get(Gdk.SELECTION_CLIPBOARD)
		self.clipboard.set_text('dev@slimbook.es', -1)
		os.system("notify-send 'Slimbook Battery' '"+ (_("strprintemailcopied")) +"' -i '" + '/usr/share/slimbookbattery/images/normal.png' + "'")

	def on_buttonRestGeneral_clicked(self, buttonRestGeneral):
		pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
			filename='/usr/share/slimbookbattery/images/normal.png',
			width=90,
			height=90,
			preserve_aspect_ratio=True)
		icon_MsgDialog = Gtk.Image.new_from_pixbuf(pixbuf)
		icon_MsgDialog.show()

		dialog = Gtk.MessageDialog(type=Gtk.MessageType.QUESTION,
			buttons=Gtk.ButtonsType.YES_NO,
			message_format=(_('stralertdialog')))
		dialog.set_image(icon_MsgDialog)
		dialog.format_secondary_text(_('strmessagerestoredefaultvalues'))
		response = dialog.run()
		if response == Gtk.ResponseType.YES:
			#BACKUP por si el usuario no introduce la contraseña para restaurar el archivo a cómo estaba anteriormente
			os.system('cp '+ user +'/.config/slimbookbattery/slimbookbattery.conf '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf')
			os.system('cp '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup')
			os.system('cp '+ user +'/.config/slimbookbattery/custom/equilibrado '+ user +'/.config/slimbookbattery/equilibrado_backup')
			os.system('cp '+ user +'/.config/slimbookbattery/custom/maximorendimiento '+ user +'/.config/slimbookbattery/maximorendimiento_backup')

			os.system('rm '+ user +'/.config/slimbookbattery/slimbookbattery.conf')
			os.system('rm '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
			os.system('rm '+ user +'/.config/slimbookbattery/custom/equilibrado')
			os.system('rm '+ user +'/.config/slimbookbattery/custom/maximorendimiento')

			os.system('cp /usr/share/slimbookbattery/slimbookbattery.conf '+ user +'/.config/slimbookbattery/slimbookbattery.conf')
			os.system('cp '+ user +'/.config/slimbookbattery/default/ahorrodeenergia '+ user +'/.config/slimbookbattery/custom/')
			os.system('cp '+ user +'/.config/slimbookbattery/default/equilibrado '+ user +'/.config/slimbookbattery/custom/')
			os.system('cp '+ user +'/.config/slimbookbattery/default/maximorendimiento '+ user +'/.config/slimbookbattery/custom/')

			if os.system('prime-select query') == 0:
				graphicsBefore = subprocess.getoutput('prime-select query')

			if os.system("pkexec python3 /usr/share/slimbookbattery/slimbookbattery-changemode.pyc equilibrado "+ user + " 'stop'") == 0:
				os.system("cp /usr/share/slimbookbattery/slimbookbattery-autostart.desktop ~/.config/autostart/")
				os.system('rm '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf')
				os.system('rm '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup')
				os.system('rm '+ user +'/.config/slimbookbattery/equilibrado_backup')
				os.system('rm '+ user +'/.config/slimbookbattery/maximorendimiento_backup')
				os.system('/usr/share/slimbookbattery/bin/workmode.x BAT')
				self.destroy()
			else:
				os.system('cp '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf '+ user +'/.config/slimbookbattery/slimbookbattery.conf')
				os.system('rm '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf')
				os.system('cp '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
				os.system('rm '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup')
				os.system('cp '+ user +'/.config/slimbookbattery/equilibrado_backup '+ user +'/.config/slimbookbattery/custom/equilibrado')
				os.system('rm '+ user +'/.config/slimbookbattery/equilibrado_backup')
				os.system('cp '+ user +'/.config/slimbookbattery/maximorendimiento_backup '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
				self.destroy()
			
			if os.system('prime-select query') == 0:
				graphicsAfter = subprocess.getoutput('prime-select query')
				if graphicsBefore != graphicsAfter:
					rebootNvidia()

		elif response == Gtk.ResponseType.NO:
			print(_('strprintrestorevaluescancel'))

		dialog.destroy()

	#CHECKs GENERAL
	def check_autostart_switchAutostart(self, switchAutostart):
		stat = str(int(config['CONFIGURATION']['autostart']))
		active = None
		user = getpass.getuser()
		if (os.path.isfile("/home/" + user + "/.config/autostart/slimbookbattery-autostart.desktop")):
				active = True
		else:
				active = False

		return active

	def check_autostart_switchOnOff(self, switchOnOff):
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')
		stat = str(int(config['CONFIGURATION']['application_on']))
		active = None
		user2 = getpass.getuser()
		if stat == '1':
			active = True
		elif stat == '0':
			active = False

		return active

	def check_autostart_WorkMode(self, comboBoxWorkMode):
		#Se mirará el archivo original de tlp para poder comprobar que modo tiene activo.
		#Esto se comprueba para poder devolver 0 o 1 y en el combobox poder mostrar como seleccionado el que esta activo actualmente.
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'TLP_DEFAULT_MODE=AC'") == 0:
			return 0
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'TLP_DEFAULT_MODE=BAT'") == 0:
			return 1

	def check_autostart_ActualMode(self, comboBoxActualMode):
		config.read(user +'/.config/slimbookbattery/slimbookbattery.conf')
		stat = str(int(config['CONFIGURATION']['modo_actual']))
		active = None
		user2 = getpass.getuser()
		if stat == '1':
			return 0
		elif stat == '2':
			return 1
		elif stat == '3':
			return 2

	def check_autostart_switchIcon(self, switchIcon):
		stat = str(int(config['CONFIGURATION']['icono']))
		active4 = None
		user4 = getpass.getuser()
		if stat == '1':
			active4 = True
		else:
			active4 = False

		return active4
	
	def check_autostart_switchHibernate(self, switchHibernate):
		stat = str(int(config['CONFIGURATION']['hibernate_after_suspension']))
		user = getpass.getuser()
		if stat == '1':
			return True
		else:
			return False

	#CHECKs AHORRO DE ENERGIA
	def check_autostart_switchSound(self, switchSound):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'SOUND_POWER_SAVE_ON_BAT=1'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWifiPower(self, switchWifiPower):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'WIFI_PWR_ON_BAT=on'") == 0:
			return True
		else:
			return False

	def check_autostart_switchBluetoothOS(self, switchBluetoothOS):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_DISABLE_ON_STARTUP' | grep 'bluetooth'") == 0:
			return True
		else:
			return False

	def check_autostart_switchAnimations(self, switchAnimations):
		stat = config['SETTINGS']['ahorro_animations']
		if stat == '0':
			return True
		elif stat == '1':
			return False

	def check_autostart_switchWifiOS(self, switchWifiOS):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_DISABLE_ON_STARTUP' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_comboBoxLimitCPU(self, comboBoxLimitCPU):
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')

		if config['SETTINGS']['limit_cpu_ahorro'] == '1':
			return 0
		elif config['SETTINGS']['limit_cpu_ahorro'] == '2':
			return 1
		elif config['SETTINGS']['limit_cpu_ahorro'] == '3':
			return 2

	def check_autostart_switchBluetoothNIU(self, switchBluetoothNIU):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'bluetooth'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWifiNIU(self, switchWifiNIU):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWWAN(self, switchWWAN):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'wwan'") == 0:
			return True
		else:
			return False

	def check_autostart_switchDisableLAN(self, switchWifiDisableLAN):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_DISABLE_ON_LAN_CONNECT' | grep 'wifi'") == 0 and os.system("cat " + user + "/.config/slimbookbattery/custom/ahorrodeenergia | grep 'DEVICES_TO_ENABLE_ON_LAN_DISCONNECT' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_switchGraphics(self, switchGraphics):
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')
		if config['SETTINGS']['graphics_ahorro'] == '0':
			return False
		elif config['SETTINGS']['graphics_ahorro'] == '1':
			return True

	def check_ahorroBrightness(self):
		ahorroBrightness = config['SETTINGS']['ahorro_brightness']
		return ahorroBrightness

	def check_autostart_USBSuspend(self, switchUSBSuspend):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_AUTOSUSPEND=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_AUTOSUSPEND=1'") == 0:
			return True

	def on_switchUSBSuspend_change(self, switchUSBSuspend, gparam):
		if switchUSBSuspend.get_active():
			self.entryBlacklistUSBIDs.set_text(str(self.check_autostart_BlacklistUSBIDs(self.entryBlacklistUSBIDs)))
			self.entryBlacklistUSBIDs.set_sensitive(True)
			
			self.switchBlacklistBUSB.set_sensitive(True)

			#self.switchBlacklistPUSB.set_sensitive(True)

			self.switchBlacklistPrintUSB.set_sensitive(True)

			self.switchBlacklistWWANUSB.set_sensitive(True)

			self.switchShutdownSuspendUSB.set_sensitive(True)
		else:
			self.entryBlacklistUSBIDs.set_text('')
			self.entryBlacklistUSBIDs.set_sensitive(False)
			
			self.switchBlacklistBUSB.set_active(False)
			self.switchBlacklistBUSB.set_sensitive(False)

			#self.switchBlacklistPUSB.set_active(False)
			#self.switchBlacklistPUSB.set_sensitive(False)

			self.switchBlacklistPrintUSB.set_active(False)
			self.switchBlacklistPrintUSB.set_sensitive(False)

			self.switchBlacklistWWANUSB.set_active(False)
			self.switchBlacklistWWANUSB.set_sensitive(False)

			self.switchShutdownSuspendUSB.set_active(False)
			self.switchShutdownSuspendUSB.set_sensitive(False)

	def check_autostart_BlacklistUSBIDs(self, entryBlacklistUSBIDs):
		USBBlacklist = subprocess.getoutput('cat '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia | grep USB_BLACKLIST=')
		pos1 = USBBlacklist.find('\"') + 1
		pos2 = len(USBBlacklist) - 2
		USBBlacklist = USBBlacklist[pos1:pos2]
		return USBBlacklist

	def check_autostart_BlacklistBUSB(self, switchBlacklistBUSB):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_BTUSB=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_BTUSB=1'") == 0:
			return True

	'''def check_autostart_BlacklistPUSB(self, switchBlacklistPUSB):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_PHONE=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_PHONE=1'") == 0:
			return True'''

	def check_autostart_BlacklistPrintUSB(self, switchBlacklistPrintUSB):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_PRINTER=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_PRINTER=1'") == 0:
			return True

	def check_autostart_BlacklistWWANUSB(self, switchBlacklistWWANUSB):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_WWAN=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_BLACKLIST_WWAN=1'") == 0:
			return True

	def check_autostart_ShutdownSuspendUSB(self, switchShutdownSuspendUSB):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_AUTOSUSPEND_DISABLE_ON_SHUTDOWN=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/ahorrodeenergia | grep 'USB_AUTOSUSPEND_DISABLE_ON_SHUTDOWN=1'") == 0:
			return True

	#CHECKs EQUILIBRADO
	def check_autostart_switchSound2(self, switchSound2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'SOUND_POWER_SAVE_ON_BAT=1'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWifiPower2(self, switchWifiPower2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'WIFI_PWR_ON_BAT=on'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWifiOS2(self, switchWifiOS2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'DEVICES_TO_DISABLE_ON_STARTUP' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_switchBluetoothOS2(self, switchBluetoothOS2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'DEVICES_TO_DISABLE_ON_STARTUP' | grep 'bluetooth'") == 0:
			return True
		else:
			return False

	def check_autostart_switchAnimations2(self, switchAnimations2):
		stat = config['SETTINGS']['equilibrado_animations']
		if stat == '0':
			return True
		elif stat == '1':
			return False

	def check_autostart_comboBoxLimitCPU2(self, comboBoxLimitCPU2):
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')

		if config['SETTINGS']['limit_cpu_equilibrado'] == '1':
			return 0
		elif config['SETTINGS']['limit_cpu_equilibrado'] == '2':
			return 1
		elif config['SETTINGS']['limit_cpu_equilibrado'] == '3':
			return 2

	def check_autostart_Governor2(self, comboBoxGovernor2, governor_name):
		if governor_name == 'intel_pstate':
			if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=powersave'") == 0:
				return 0
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=performance'") == 0:
				return 1
		elif governor_name == 'acpi-cpufreq':
			if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=ondemand'") == 0:
				return 0
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=schedutil'") == 0:
				return 1
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=powersave'") == 0:
				return 2
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=performance'") == 0:
				return 3
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'CPU_SCALING_GOVERNOR_ON_BAT=conservative'") == 0:
				return 4

	def check_autostart_switchBluetoothNIU2(self, switchBluetoothNIU2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'bluetooth'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWifiNIU2(self, switchWifiNIU2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_switchDisableLAN2(self, switchWifiDisableLAN2):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'DEVICES_TO_DISABLE_ON_LAN_CONNECT' | grep 'wifi'") == 0 and os.system("cat " + user + "/.config/slimbookbattery/custom/equilibrado | grep 'DEVICES_TO_ENABLE_ON_LAN_DISCONNECT' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_switchGraphics2(self, switchGraphics2):
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')
		if config['SETTINGS']['graphics_equilibrado'] == '0':
			return False
		elif config['SETTINGS']['graphics_equilibrado'] == '1':
			return True

	def check_equilibradoBrightness(self):
		equilibradoBrightness = config['SETTINGS']['equilibrado_brightness']
		return equilibradoBrightness

	def check_autostart_USBSuspend2(self, switchUSBSuspend2):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_AUTOSUSPEND=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_AUTOSUSPEND=1'") == 0:
			return True

	def on_switchUSBSuspend2_change(self, switchUSBSuspend2, gparam):
		if switchUSBSuspend2.get_active():
			self.entryBlacklistUSBIDs2.set_text(str(self.check_autostart_BlacklistUSBIDs2(self.entryBlacklistUSBIDs2)))
			self.entryBlacklistUSBIDs2.set_sensitive(True)
			
			self.switchBlacklistBUSB2.set_sensitive(True)

			#self.switchBlacklistPUSB2.set_sensitive(True)

			self.switchBlacklistPrintUSB2.set_sensitive(True)

			self.switchBlacklistWWANUSB2.set_sensitive(True)

			self.switchShutdownSuspendUSB2.set_sensitive(True)
		else:
			self.entryBlacklistUSBIDs2.set_text('')
			self.entryBlacklistUSBIDs2.set_sensitive(False)
			
			self.switchBlacklistBUSB2.set_active(False)
			self.switchBlacklistBUSB2.set_sensitive(False)

			#self.switchBlacklistPUSB2.set_active(False)
			#self.switchBlacklistPUSB2.set_sensitive(False)

			self.switchBlacklistPrintUSB2.set_active(False)
			self.switchBlacklistPrintUSB2.set_sensitive(False)

			self.switchBlacklistWWANUSB2.set_active(False)
			self.switchBlacklistWWANUSB2.set_sensitive(False)

			self.switchShutdownSuspendUSB2.set_active(False)
			self.switchShutdownSuspendUSB2.set_sensitive(False)

	def check_autostart_BlacklistUSBIDs2(self, entryBlacklistUSBIDs2):
		USBBlacklist2 = subprocess.getoutput('cat '+ user +'/.config/slimbookbattery/custom/equilibrado | grep USB_BLACKLIST=')
		pos1 = USBBlacklist2.find('\"') + 1
		pos2 = len(USBBlacklist2) - 2
		USBBlacklist2 = USBBlacklist2[pos1:pos2]
		return USBBlacklist2

	def check_autostart_BlacklistBUSB2(self, switchBlacklistBUSB2):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_BTUSB=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_BTUSB=1'") == 0:
			return True

	'''def check_autostart_BlacklistPUSB2(self, switchBlacklistPUSB2):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_PHONE=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_PHONE=1'") == 0:
			return True'''

	def check_autostart_BlacklistPrintUSB2(self, switchBlacklistPrintUSB2):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_PRINTER=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_PRINTER=1'") == 0:
			return True

	def check_autostart_BlacklistWWANUSB2(self, switchBlacklistWWANUSB2):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_WWAN=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_BLACKLIST_WWAN=1'") == 0:
			return True

	def check_autostart_ShutdownSuspendUSB2(self, switchShutdownSuspendUSB2):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_AUTOSUSPEND_DISABLE_ON_SHUTDOWN=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/equilibrado | grep 'USB_AUTOSUSPEND_DISABLE_ON_SHUTDOWN=1'") == 0:
			return True

	#CHECKs MÁXIMO RENDIMIENTO

	def check_autostart_USBSuspend3(self, switchUSBSuspend3):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_AUTOSUSPEND=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_AUTOSUSPEND=1'") == 0:
			return True
			
	def check_autostart_switchWifiOS3(self, switchWifiOS3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'DEVICES_TO_DISABLE_ON_STARTUP' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_autostart_switchBluetoothOS3(self, switchBluetoothOS3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'DEVICES_TO_DISABLE_ON_STARTUP' | grep 'bluetooth'") == 0:
			return True
		else:
			return False

	def check_autostart_switchAnimations3(self, switchAnimations3):
		stat = config['SETTINGS']['maxrendimiento_animations']
		if stat == '0':
			return True
		elif stat == '1':
			return False

	def check_autostart_switchDisableLAN3(self, switchWifiDisableLAN3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'DEVICES_TO_DISABLE_ON_LAN_CONNECT' | grep 'wifi'") == 0 and os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'DEVICES_TO_ENABLE_ON_LAN_DISCONNECT' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def on_switchUSBSuspend3_change(self, switchUSBSuspend3, gparam):
		if switchUSBSuspend3.get_active():
			self.entryBlacklistUSBIDs3.set_text(str(self.check_autostart_BlacklistUSBIDs3(self.entryBlacklistUSBIDs3)))
			self.entryBlacklistUSBIDs3.set_sensitive(True)
			
			self.switchBlacklistBUSB3.set_sensitive(True)

			#self.switchBlacklistPUSB3.set_sensitive(True)

			self.switchBlacklistPrintUSB3.set_sensitive(True)

			self.switchBlacklistWWANUSB3.set_sensitive(True)

			self.switchShutdownSuspendUSB3.set_sensitive(True)
		else:
			self.entryBlacklistUSBIDs3.set_text('')
			self.entryBlacklistUSBIDs3.set_sensitive(False)
			
			self.switchBlacklistBUSB3.set_active(False)
			self.switchBlacklistBUSB3.set_sensitive(False)

			#self.switchBlacklistPUSB3.set_active(False)
			#self.switchBlacklistPUSB3.set_sensitive(False)

			self.switchBlacklistPrintUSB3.set_active(False)
			self.switchBlacklistPrintUSB3.set_sensitive(False)

			self.switchBlacklistWWANUSB3.set_active(False)
			self.switchBlacklistWWANUSB3.set_sensitive(False)

			self.switchShutdownSuspendUSB3.set_active(False)
			self.switchShutdownSuspendUSB3.set_sensitive(False)

	def check_autostart_BlacklistUSBIDs3(self, entryBlacklistUSBIDs3):
		USBBlacklist3 = subprocess.getoutput('cat '+ user +'/.config/slimbookbattery/custom/maximorendimiento | grep USB_BLACKLIST=')
		pos1 = USBBlacklist3.find('\"') + 1
		pos2 = len(USBBlacklist3) - 2
		USBBlacklist3 = USBBlacklist3[pos1:pos2]
		return USBBlacklist3

	def check_autostart_BlacklistBUSB3(self, switchBlacklistBUSB3):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_BTUSB=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_BTUSB=1'") == 0:
			return True

	'''def check_autostart_BlacklistPUSB3(self, switchBlacklistPUSB3):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_PHONE=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_PHONE=1'") == 0:
			return True'''

	def check_autostart_BlacklistPrintUSB3(self, switchBlacklistPrintUSB3):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_PRINTER=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_PRINTER=1'") == 0:
			return True

	def check_autostart_BlacklistWWANUSB3(self, switchBlacklistWWANUSB3):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_WWAN=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_BLACKLIST_WWAN=1'") == 0:
			return True

	def check_autostart_ShutdownSuspendUSB3(self, switchShutdownSuspendUSB3):
		if os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_AUTOSUSPEND_DISABLE_ON_SHUTDOWN=0'") == 0:
			return False
		elif os.system("cat "+ user +"/.config/slimbookbattery/custom/maximorendimiento | grep 'USB_AUTOSUSPEND_DISABLE_ON_SHUTDOWN=1'") == 0:
			return True

	def check_autostart_switchSound3(self, switchSound3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'SOUND_POWER_SAVE_ON_BAT=1'") == 0:
			return True
		elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'SOUND_POWER_SAVE_ON_BAT=0'") == 0:
			return False

	def check_autostart_switchWifiPower3(self, switchWifiPower3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'WIFI_PWR_ON_BAT=on'") == 0:
			return True
		elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'WIFI_PWR_ON_BAT=off'") == 0:
			return False

	def check_autostart_Governor3(self, comboBoxGovernor3, governor_name):
		if governor_name == 'intel_pstate':
			if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=powersave'") == 0:
				return 0
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=performance'") == 0:
				return 1
		elif governor_name == 'acpi-cpufreq':
			if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=ondemand'") == 0:
				return 0
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=schedutil'") == 0:
				return 1
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=powersave'") == 0:
				return 2
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=performance'") == 0:
				return 3
			elif os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'CPU_SCALING_GOVERNOR_ON_BAT=conservative'") == 0:
				return 4

	def check_autostart_comboBoxLimitCPU3(self, comboBoxLimitCPU3):
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')

		if config['SETTINGS']['limit_cpu_maximorendimiento'] == '1':
			return 0
		elif config['SETTINGS']['limit_cpu_maximorendimiento'] == '2':
			return 1
		elif config['SETTINGS']['limit_cpu_maximorendimiento'] == '3':
			return 2

	def check_autostart_switchBluetoothNIU3(self, switchBluetoothNIU3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'bluetooth'") == 0:
			return True
		else:
			return False

	def check_autostart_switchWifiNIU3(self, switchWifiNIU3):
		if os.system("cat " + user + "/.config/slimbookbattery/custom/maximorendimiento | grep 'DEVICES_TO_DISABLE_ON_BAT_NOT_IN_USE' | grep 'wifi'") == 0:
			return True
		else:
			return False

	def check_maxrendimientoBrightness(self):
		maxrendimientoBrightness = config['SETTINGS']['maxrendimiento_brightness']
		return maxrendimientoBrightness

	#CHECKs cycles
	def check_autostart_switchAlerts(self, switchAlerts):
		stat = str(int(config['CONFIGURATION']['alerts']))
		active = None
		user = getpass.getuser()
		if stat == '1':
			active = True
		elif stat == '0':
			active = False

		return active

	def check_value_max(self):
		max_battery = config['CONFIGURATION']['max_battery_value']
		return max_battery

	def check_value_min(self):
		min_battery = config['CONFIGURATION']['min_battery_value']
		return min_battery

	def check_times_max(self):
		max_times = config['CONFIGURATION']['max_battery_times']
		return max_times

	def check_times_min(self):
		time_warnings = config['CONFIGURATION']['time_between_warnings']
		return time_warnings

	#ON_SWITCH_ACTIVATED
	def on_switch_activated(self, switch):
		if switch.get_active():
			state = "on"
			return state
		else:
			state = "off"
			return state

	#Aplica los cambios a la configuración del usuario del archivo slimbookbattery.conf
	def on_save_configuration(self, scaleMaxBatVal, scaleMinBatVal, scaleNumTimes, scaleTimeWarnings):
		#config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')
		config.set('CONFIGURATION', 'max_battery_value', str(int(self.scaleMaxBatVal.get_value())))
		config.set('CONFIGURATION', 'min_battery_value', str(int(self.scaleMinBatVal.get_value())))
		config.set('CONFIGURATION', 'max_battery_times', str(int(self.scaleNumTimes.get_value())))
		config.set('CONFIGURATION', 'time_between_warnings', str(int(self.scaleTimeWarnings.get_value())))

		configfile = open(user + '/.config/slimbookbattery/slimbookbattery.conf', 'w')
		config.write(configfile)
		configfile.close()

	def messagedialog(self, title, message):
		dialog = Gtk.MessageDialog(None,
			Gtk.DialogFlags.MODAL,
			Gtk.MessageType.INFO,
			buttons=Gtk.ButtonsType.OK)
		dialog.set_markup("<b>%s</b>" % title)
		dialog.format_secondary_markup(message)
		dialog.run()
		dialog.destroy()

	def close_ok(self):
		#Se vuelve a leer el archivo de configuración del usuario para comprobar si ha habido algún cambio anteriormente
		config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')

		#Se realiza un backup por si el usuario cancela la introducción de la contraseña más adelante cuando se solicita
		os.system('cp '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup')
		os.system('cp '+ user +'/.config/slimbookbattery/custom/equilibrado '+ user +'/.config/slimbookbattery/equilibrado_backup')
		os.system('cp '+ user +'/.config/slimbookbattery/custom/maximorendimiento '+ user +'/.config/slimbookbattery/maximorendimiento_backup')
		os.system('cp '+ user +'/.config/slimbookbattery/slimbookbattery.conf '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf')
		statAlerts = self.on_switch_activated(self.switchAlerts)
		if statAlerts == "on":
			config.set('CONFIGURATION', 'alerts', str(1))
		elif statAlerts == "off":
			config.set('CONFIGURATION', 'alerts', str(0))

		statWorkMode = self.comboBoxWorkMode.get_active_iter()
		if statWorkMode is not None:
			model = self.comboBoxWorkMode.get_model()
			row_id, name = model[statWorkMode][:2]
			if name == 'BAT':
				os.system('/usr/share/slimbookbattery/bin/workmode.x BAT')
			elif name == 'AC':
				os.system('/usr/share/slimbookbattery/bin/workmode.x AC')

		statModoActual = self.comboBoxActualMode.get_active_iter()
		if statModoActual is not None:
			model = self.comboBoxActualMode.get_model()
			row_id, name = model[statModoActual][:2]
			if name == (_('strenergysaving')):
				config.set('CONFIGURATION', 'modo_actual', '1')
			elif name == (_('strbalanced')):
				config.set('CONFIGURATION', 'modo_actual', '2')
			elif name == (_('strmaximumperformance')):
				config.set('CONFIGURATION', 'modo_actual', '3')
			
			configfile = open(user + '/.config/slimbookbattery/slimbookbattery.conf', 'w')
			config.write(configfile)
			configfile.close()

		#CAMBIOS AHORRO DE ENERGIA
		statSound = self.on_switch_activated(self.switchSound)
		if statSound == "on":
			os.system('/usr/share/slimbookbattery/bin/sound.x 1')
		elif statSound == "off":
			os.system('/usr/share/slimbookbattery/bin/sound.x 0')
		
		statWifiPower = self.on_switch_activated(self.switchWifiPower)
		if statWifiPower == "on":
			os.system('/usr/share/slimbookbattery/bin/wifipower.x on')
		elif statWifiPower == "off":
			os.system('/usr/share/slimbookbattery/bin/wifipower.x off')

		if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
			statAnimations = self.on_switch_activated(self.switchAnimations)
			if statAnimations == "on":
				config.set('SETTINGS', 'ahorro_animations', '0')
			elif statAnimations == "off":
				config.set('SETTINGS', 'ahorro_animations', '1')
		
		statBluetoothOS = self.on_switch_activated(self.switchBluetoothOS)
		statWifiOS = self.on_switch_activated(self.switchWifiOS)
		if statBluetoothOS == "on" and statWifiOS == "on":
			os.system('/usr/share/slimbookbattery/bin/bootstart.x bluetooth wifi')
		elif statBluetoothOS == "on" and statWifiOS == "off":
			os.system('/usr/share/slimbookbattery/bin/bootstart.x bluetooth')
		elif statBluetoothOS == "off" and statWifiOS == "on":
			os.system('/usr/share/slimbookbattery/bin/bootstart.x wifi')
		elif statBluetoothOS == "off" and statWifiOS == "off":
			os.system('/usr/share/slimbookbattery/bin/bootstart.x')

		statLimitCPU = self.comboBoxLimitCPU.get_active_iter()
		if statLimitCPU is not None:
			model = self.comboBoxLimitCPU.get_model()
			row_id, name = model[statLimitCPU][:2]
			if name == (_('strmaximumlimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu.x 1')
				config.set('SETTINGS', 'limit_cpu_ahorro', '1')
			elif name == (_('strmediumlimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu.x 2')
				config.set('SETTINGS', 'limit_cpu_ahorro', '2')
			elif name == (_('strnonelimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu.x 3')
				config.set('SETTINGS', 'limit_cpu_ahorro', '3')

		statBluetoothNIU = self.on_switch_activated(self.switchBluetoothNIU)
		statWifiNIU = self.on_switch_activated(self.switchWifiNIU)
		if statBluetoothNIU == "on" and statWifiNIU == "on":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse.x bluetooth wifi')
		elif statBluetoothNIU == "on" and statWifiNIU == "off":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse.x bluetooth')
		elif statBluetoothNIU == "off" and statWifiNIU == "on":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse.x wifi')
		elif statBluetoothNIU == "off" and statWifiNIU == "off":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse.x')

		statWifiDisableLAN = self.on_switch_activated(self.switchWifiDisableLAN)
		if statWifiDisableLAN == "on":
			os.system('/usr/share/slimbookbattery/bin/wifidisablelan.x on')
		elif statWifiDisableLAN == "off":
			os.system('/usr/share/slimbookbattery/bin/wifidisablelan.x off')

		statGraphics = self.on_switch_activated(self.switchGraphics)
		if statGraphics == "on":
			config.set('SETTINGS', 'graphics_ahorro', str(1))
		elif statGraphics == "off":
			config.set('SETTINGS', 'graphics_ahorro', str(0))

		#Aquí se tiene que modificar ya el valor del brillo de la pantalla y los gráficos, ya que cuando se apliquen los cambios no se aplicaran los cambios al instante sobre el modo que se este usando.
		configfile = open(user + '/.config/slimbookbattery/slimbookbattery.conf', 'w')
		config.set('SETTINGS', 'ahorro_brightness', str(int(self.scaleBrightness.get_value())))
		config.write(configfile)
		configfile.close()

		statUSBSuspend = self.on_switch_activated(self.switchUSBSuspend)
		if statUSBSuspend == "on":
			os.system('/usr/share/slimbookbattery/bin/usbsuspend.x 1')
		elif statUSBSuspend == "off":
			os.system('/usr/share/slimbookbattery/bin/usbsuspend.x 0')

		textBlacklistUSBIDs = self.entryBlacklistUSBIDs.get_text()
		textBlacklistUSBIDs = '\"'+ textBlacklistUSBIDs + '\"'
		os.system('/usr/share/slimbookbattery/bin/blacklistusbids.x '+ textBlacklistUSBIDs)

		statBlacklistBUSB = self.on_switch_activated(self.switchBlacklistBUSB)
		if statBlacklistBUSB == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistbluetoothusb.x 1')
		elif statBlacklistBUSB == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistbluetoothusb.x 0')

		'''statBlacklistPUSB = self.on_switch_activated(self.switchBlacklistPUSB)
		if statBlacklistPUSB == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistphoneusb.x 1')
		elif statBlacklistPUSB == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistphoneusb.x 0')'''

		statBlacklistPrintUSB = self.on_switch_activated(self.switchBlacklistPrintUSB)
		if statBlacklistPrintUSB == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistprintusb.x 1')
		elif statBlacklistPrintUSB == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistprintusb.x 0')

		statBlacklistWWANUSB = self.on_switch_activated(self.switchBlacklistWWANUSB)
		if statBlacklistWWANUSB == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistwwanusb.x 1')
		elif statBlacklistWWANUSB == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistwwanusb.x 0')

		statShutdownSuspendUSB = self.on_switch_activated(self.switchShutdownSuspendUSB)
		if statShutdownSuspendUSB == "on":
			os.system('/usr/share/slimbookbattery/bin/shutdownsuspendusb.x 1')
		elif statShutdownSuspendUSB == "off":
			os.system('/usr/share/slimbookbattery/bin/shutdownsuspendusb.x 0')

		#CAMBIOS EQUILIBRADO
		statSound2 = self.on_switch_activated(self.switchSound2)
		if statSound2 == "on":
			os.system('/usr/share/slimbookbattery/bin/sound2.x 1')
		elif statSound2 == "off":
			os.system('/usr/share/slimbookbattery/bin/sound2.x 0')

		statWifiPower2 = self.on_switch_activated(self.switchWifiPower2)
		if statWifiPower2 == "on":
			os.system('/usr/share/slimbookbattery/bin/wifipower2.x on')
		elif statWifiPower2 == "off":
			os.system('/usr/share/slimbookbattery/bin/wifipower2.x off')

		if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
			statAnimations2 = self.on_switch_activated(self.switchAnimations2)
			if statAnimations2 == "on":
				config.set('SETTINGS', 'equilibrado_animations', '0')
			elif statAnimations2 == "off":
				config.set('SETTINGS', 'equilibrado_animations', '1')

		statBluetoothOS2 = self.on_switch_activated(self.switchBluetoothOS2)
		statWifiOS2 = self.on_switch_activated(self.switchWifiOS2)
		if statBluetoothOS2 == "on" and statWifiOS2 == "on":
			os.system('/usr/share/slimbookbattery/bin/bootstart2.x bluetooth wifi')
		elif statBluetoothOS2 == "on" and statWifiOS2 == "off":
			os.system('/usr/share/slimbookbattery/bin/bootstart2.x bluetooth')
		elif statBluetoothOS2 == "off" and statWifiOS2 == "on":
			os.system('/usr/share/slimbookbattery/bin/bootstart2.x wifi')
		elif statBluetoothOS2 == "off" and statWifiOS2 == "off":
			os.system('/usr/share/slimbookbattery/bin/bootstart2.x')

		governorCompatible, governor_name = governorIsCompatible()
		if governorCompatible == True:
			statGovernor2 = self.comboBoxGovernor2.get_active_iter()
			if statGovernor2 is not None:
				model = self.comboBoxGovernor2.get_model()
				row_id, name = model[statGovernor2][:2]
				if name == "powersave":
					os.system('/usr/share/slimbookbattery/bin/governor2.x powersave')
				elif name == "performance":
					os.system('/usr/share/slimbookbattery/bin/governor2.x performance')
				elif name == "ondemand":
					os.system('/usr/share/slimbookbattery/bin/governor2.x ondemand')
				elif name == "schedutil":
					os.system('/usr/share/slimbookbattery/bin/governor2.x schedutil')
				elif name == "conservative":
					os.system('/usr/share/slimbookbattery/bin/governor2.x conservative')

		statLimitCPU2 = self.comboBoxLimitCPU2.get_active_iter()
		if statLimitCPU2 is not None:
			model = self.comboBoxLimitCPU2.get_model()
			row_id, name = model[statLimitCPU2][:2]
			if name == (_('strmaximumlimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu2.x 1')
				config.set('SETTINGS', 'limit_cpu_equilibrado', '1')
			elif name == (_('strmediumlimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu2.x 2')
				config.set('SETTINGS', 'limit_cpu_equilibrado', '2')
			elif name == (_('strnonelimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu2.x 3')
				config.set('SETTINGS', 'limit_cpu_equilibrado', '3')

		statBluetoothNIU2 = self.on_switch_activated(self.switchBluetoothNIU2)
		statWifiNIU2 = self.on_switch_activated(self.switchWifiNIU2)
		if statBluetoothNIU2 == "on" and statWifiNIU2 == "on":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse2.x bluetooth wifi')
		elif statBluetoothNIU2 == "on" and statWifiNIU2 == "off":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse2.x bluetooth')
		elif statBluetoothNIU2 == "off" and statWifiNIU2 == "on":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse2.x wifi')
		elif statBluetoothNIU2 == "off" and statWifiNIU2 == "off":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse2.x')

		statWifiDisableLAN2 = self.on_switch_activated(self.switchWifiDisableLAN2)
		if statWifiDisableLAN2 == "on":
			os.system('/usr/share/slimbookbattery/bin/wifidisablelan2.x on')
		elif statWifiDisableLAN2 == "off":
			os.system('/usr/share/slimbookbattery/bin/wifidisablelan2.x off')

		statGraphics2 = self.on_switch_activated(self.switchGraphics2)
		if statGraphics2 == "on":
			config.set('SETTINGS', 'graphics_equilibrado', str(1))
		elif statGraphics2 == "off":
			config.set('SETTINGS', 'graphics_equilibrado', str(0))
		
		#Aquí se tiene que modificar ya el valor del brillo de la pantalla y los gráficos, ya que cuando se apliquen los cambios no se aplicaran los cambios al instante sobre el modo que se este usando.
		configfile = open(user + '/.config/slimbookbattery/slimbookbattery.conf', 'w')
		config.set('SETTINGS', 'equilibrado_brightness', str(int(self.scaleBrightness2.get_value())))
		config.write(configfile)
		configfile.close()

		statUSBSuspend2 = self.on_switch_activated(self.switchUSBSuspend2)
		if statUSBSuspend2 == "on":
			os.system('/usr/share/slimbookbattery/bin/usbsuspend2.x 1')
		elif statUSBSuspend2 == "off":
			os.system('/usr/share/slimbookbattery/bin/usbsuspend2.x 0')

		textBlacklistUSBIDs2 = self.entryBlacklistUSBIDs2.get_text()
		textBlacklistUSBIDs2 = '\"'+ textBlacklistUSBIDs2 + '\"'
		os.system('/usr/share/slimbookbattery/bin/blacklistusbids2.x '+ textBlacklistUSBIDs2)

		statBlacklistBUSB2 = self.on_switch_activated(self.switchBlacklistBUSB2)
		if statBlacklistBUSB2 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistbluetoothusb2.x 1')
		elif statBlacklistBUSB2 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistbluetoothusb2.x 0')

		'''statBlacklistPUSB2 = self.on_switch_activated(self.switchBlacklistPUSB2)
		if statBlacklistPUSB2 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistphoneusb2.x 1')
		elif statBlacklistPUSB2 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistphoneusb2.x 0')'''

		statBlacklistPrintUSB2 = self.on_switch_activated(self.switchBlacklistPrintUSB2)
		if statBlacklistPrintUSB2 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistprintusb2.x 1')
		elif statBlacklistPrintUSB2 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistprintusb2.x 0')

		statBlacklistWWANUSB2 = self.on_switch_activated(self.switchBlacklistWWANUSB2)
		if statBlacklistWWANUSB2 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistwwanusb2.x 1')
		elif statBlacklistWWANUSB2 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistwwanusb2.x 0')

		statShutdownSuspendUSB2 = self.on_switch_activated(self.switchShutdownSuspendUSB2)
		if statShutdownSuspendUSB2 == "on":
			os.system('/usr/share/slimbookbattery/bin/shutdownsuspendusb2.x 1')
		elif statShutdownSuspendUSB2 == "off":
			os.system('/usr/share/slimbookbattery/bin/shutdownsuspendusb2.x 0')

		#CAMBIOS MÁXIMO RENDIMIENTO

		statUSBSuspend3 = self.on_switch_activated(self.switchUSBSuspend3)
		if statUSBSuspend3 == "on":
			os.system('/usr/share/slimbookbattery/bin/usbsuspend3.x 1')
		elif statUSBSuspend3 == "off":
			os.system('/usr/share/slimbookbattery/bin/usbsuspend3.x 0')

		statWifiDisableLAN3 = self.on_switch_activated(self.switchWifiDisableLAN3)
		if statWifiDisableLAN3 == "on":
			os.system('/usr/share/slimbookbattery/bin/wifidisablelan3.x on')
		elif statWifiDisableLAN3 == "off":
			os.system('/usr/share/slimbookbattery/bin/wifidisablelan3.x off')
		
		if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
			statAnimations3 = self.on_switch_activated(self.switchAnimations3)
			if statAnimations3 == "on":
				config.set('SETTINGS', 'maxrendimiento_animations', '0')
			elif statAnimations3 == "off":
				config.set('SETTINGS', 'maxrendimiento_animations', '1')

		statBluetoothOS3 = self.on_switch_activated(self.switchBluetoothOS3)
		statWifiOS3 = self.on_switch_activated(self.switchWifiOS3)
		if statBluetoothOS3 == "on" and statWifiOS3 == "on":
			os.system('/usr/share/slimbookbattery/bin/bootstart3.x bluetooth wifi')
		elif statBluetoothOS3 == "on" and statWifiOS3 == "off":
			os.system('/usr/share/slimbookbattery/bin/bootstart3.x bluetooth')
		elif statBluetoothOS3 == "off" and statWifiOS3 == "on":
			os.system('/usr/share/slimbookbattery/bin/bootstart3.x wifi')
		elif statBluetoothOS3 == "off" and statWifiOS3 == "off":
			os.system('/usr/share/slimbookbattery/bin/bootstart3.x')

		textBlacklistUSBIDs3 = self.entryBlacklistUSBIDs3.get_text()
		textBlacklistUSBIDs3 = '\"'+ textBlacklistUSBIDs3 + '\"'
		os.system('/usr/share/slimbookbattery/bin/blacklistusbids3.x '+ textBlacklistUSBIDs3)

		'''statBlacklistPUSB3 = self.on_switch_activated(self.switchBlacklistPUSB3)
		if statBlacklistPUSB3 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistphoneusb3.x 1')
		elif statBlacklistPUSB3 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistphoneusb3.x 0')'''

		statBlacklistBUSB3 = self.on_switch_activated(self.switchBlacklistBUSB3)
		if statBlacklistBUSB3 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistbluetoothusb3.x 1')
		elif statBlacklistBUSB3 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistbluetoothusb3.x 0')

		statBlacklistPrintUSB3 = self.on_switch_activated(self.switchBlacklistPrintUSB3)
		if statBlacklistPrintUSB3 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistprintusb3.x 1')
		elif statBlacklistPrintUSB3 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistprintusb3.x 0')

		statBlacklistWWANUSB3 = self.on_switch_activated(self.switchBlacklistWWANUSB3)
		if statBlacklistWWANUSB3 == "on":
			os.system('/usr/share/slimbookbattery/bin/blacklistwwanusb3.x 1')
		elif statBlacklistWWANUSB3 == "off":
			os.system('/usr/share/slimbookbattery/bin/blacklistwwanusb3.x 0')

		statShutdownSuspendUSB3 = self.on_switch_activated(self.switchShutdownSuspendUSB3)
		if statShutdownSuspendUSB3 == "on":
			os.system('/usr/share/slimbookbattery/bin/shutdownsuspendusb3.x 1')
		elif statShutdownSuspendUSB3 == "off":
			os.system('/usr/share/slimbookbattery/bin/shutdownsuspendusb3.x 0')

		statSound3 = self.on_switch_activated(self.switchSound3)
		if statSound3 == "on":
			os.system('/usr/share/slimbookbattery/bin/sound3.x 1')
		elif statSound3 == "off":
			os.system('/usr/share/slimbookbattery/bin/sound3.x 0')

		statWifiPower3 = self.on_switch_activated(self.switchWifiPower3)
		if statWifiPower3 == "on":
			os.system('/usr/share/slimbookbattery/bin/wifipower3.x on')
		elif statWifiPower3 == "off":
			os.system('/usr/share/slimbookbattery/bin/wifipower3.x off')

		governorCompatible, governor_name = governorIsCompatible()
		if governorCompatible == True:
			statGovernor3 = self.comboBoxGovernor3.get_active_iter()
			if statGovernor3 is not None:
				model = self.comboBoxGovernor3.get_model()
				row_id, name = model[statGovernor3][:2]
				if name == "powersave":
					os.system('/usr/share/slimbookbattery/bin/governor3.x powersave')
				elif name == "performance":
					os.system('/usr/share/slimbookbattery/bin/governor3.x performance')
				elif name == "ondemand":
					os.system('/usr/share/slimbookbattery/bin/governor3.x ondemand')
				elif name == "schedutil":
					os.system('/usr/share/slimbookbattery/bin/governor3.x schedutil')
				elif name == "conservative":
					os.system('/usr/share/slimbookbattery/bin/governor3.x conservative')

		statLimitCPU3 = self.comboBoxLimitCPU3.get_active_iter()
		if statLimitCPU3 is not None:
			model = self.comboBoxLimitCPU3.get_model()
			row_id, name = model[statLimitCPU3][:2]
			if name == (_('strmaximumlimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu3.x 1')
				config.set('SETTINGS', 'limit_cpu_maximorendimiento', '1')
			elif name == (_('strmediumlimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu3.x 2')
				config.set('SETTINGS', 'limit_cpu_maximorendimiento', '2')
			elif name == (_('strnonelimitcpu')):
				os.system('/usr/share/slimbookbattery/bin/limitcpu3.x 3')
				config.set('SETTINGS', 'limit_cpu_maximorendimiento', '3')

		statBluetoothNIU3 = self.on_switch_activated(self.switchBluetoothNIU3)
		statWifiNIU3 = self.on_switch_activated(self.switchWifiNIU3)
		if statBluetoothNIU3 == "on" and statWifiNIU3 == "on":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse3.x bluetooth wifi')
		elif statBluetoothNIU3 == "on" and statWifiNIU3 == "off":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse3.x bluetooth')
		elif statBluetoothNIU3 == "off" and statWifiNIU3 == "on":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse3.x wifi')
		elif statBluetoothNIU3 == "off" and statWifiNIU3 == "off":
			os.system('/usr/share/slimbookbattery/bin/batnotinuse3.x')

		configfile = open(user + '/.config/slimbookbattery/slimbookbattery.conf', 'w')
		config.set('SETTINGS', 'maxrendimiento_brightness', str(int(self.scaleBrightness3.get_value())))
		config.write(configfile)
		configfile.close()

		#Se comprueba si la gráfica que esta utilizando el usuario es nvidia y tiene los drivers instalados
		if os.system('prime-select query') == 0:
			graphicsBefore = subprocess.getoutput('prime-select query')

		if os.system("cat /sys/power/state | grep disk") == 0:
			statHibernate = self.on_switch_activated(self.switchHibernate)
			if statHibernate == 'on':
				config.set('CONFIGURATION', 'hibernate_after_suspension', str(int(1)))
			elif statHibernate == 'off':
				config.set('CONFIGURATION', 'hibernate_after_suspension', str(int(0)))

		statAutostart = self.on_switch_activated(self.switchAutostart)
		modo = int(config['CONFIGURATION']['modo_actual'])
		modo_selec = ""
		if modo == 1:
			modo_selec = "ahorrodeenergia"
		elif modo == 2:
			modo_selec = "equilibrado"
		elif modo == 3:
			modo_selec = "maximorendimiento"

		print((_("strcurrentmode"))+ modo_selec)
		print((_("strprintautostart")) + statAutostart)
		statOnOff = self.on_switch_activated(self.switchOnOff)
		print((_("strprintappstatus")) + statOnOff)

		#Variable para controlar si la autentificación fue correcta o no
		falloAuth = False
		#Para guardar los cambios y sobreescribir el archivo tlp con ya la configuración que ha elegido el usuario se pueden dar hasta 4 condiciones para realizarlo:
		if (statAutostart == "on" and statOnOff == "on"):
			config.set('CONFIGURATION', 'application_on', str(int(1)))
			config.set('CONFIGURATION', 'autostart', str(int(1)))
			self.on_save_configuration(self.scaleMaxBatVal, self.scaleMinBatVal, self.scaleNumTimes, self.scaleTimeWarnings)
			if os.system("pkexec python3 /usr/share/slimbookbattery/slimbookbattery-changemode.pyc " + modo_selec + " " + user + " 'start'") == 0:
				os.system("cp /usr/share/slimbookbattery/slimbookbattery-autostart.desktop ~/.config/autostart/")
			else:
				falloAuth = True
		elif (statAutostart == "on" and statOnOff == "off"):
			config.set('CONFIGURATION', 'application_on', str(int(0)))
			config.set('CONFIGURATION', 'autostart', str(int(1)))
			self.on_save_configuration(self.scaleMaxBatVal, self.scaleMinBatVal, self.scaleNumTimes, self.scaleTimeWarnings)
			if os.system("pkexec python3 /usr/share/slimbookbattery/slimbookbattery-changemode.pyc " + modo_selec + " " + user + " 'stop'") == 0:
				os.system("cp /usr/share/slimbookbattery/slimbookbattery-autostart.desktop ~/.config/autostart/")
			else:
				falloAuth = True
		elif (statAutostart == "off" and statOnOff == "on"):
			config.set('CONFIGURATION', 'application_on', str(int(1)))
			config.set('CONFIGURATION', 'autostart', str(int(0)))
			self.on_save_configuration(self.scaleMaxBatVal, self.scaleMinBatVal, self.scaleNumTimes, self.scaleTimeWarnings)
			if os.system("pkexec python3 /usr/share/slimbookbattery/slimbookbattery-changemode.pyc " + modo_selec + " " + user + " 'start'") == 0:
				os.system("rm -rf ~/.config/autostart/slimbookbattery-autostart.desktop")
			else:
				falloAuth = True
		elif (statAutostart == "off" and statOnOff == "off"):
			config.set('CONFIGURATION', 'application_on', str(int(0)))
			config.set('CONFIGURATION', 'autostart', str(int(0)))
			self.on_save_configuration(self.scaleMaxBatVal, self.scaleMinBatVal, self.scaleNumTimes, self.scaleTimeWarnings)
			if os.system("pkexec python3 /usr/share/slimbookbattery/slimbookbattery-changemode.pyc " + modo_selec + " " + user + " 'stop'") == 0:
				os.system("rm -rf ~/.config/autostart/slimbookbattery-autostart.desktop")
			else:
				falloAuth = True

		#Si no hay fallo en la autentificación se acaban de de aplicar el resto de cambios restantes
		if falloAuth == False:
			#Se eliminan los archivos de backup
			os.system('rm '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup')
			os.system('rm '+ user +'/.config/slimbookbattery/equilibrado_backup')
			os.system('rm '+ user +'/.config/slimbookbattery/maximorendimiento_backup')
			os.system('rm '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf')
			statIcon = self.on_switch_activated(self.switchIcon)
			if statIcon == "on":
				config.set('CONFIGURATION', 'icono', str(int(1)))
			elif statIcon == "off":
				config.set('CONFIGURATION', 'icono', str(int(0)))

			configfile = open(user + '/.config/slimbookbattery/slimbookbattery.conf', 'w')
			config.write(configfile)
			configfile.close()

			#Activa o desactiva las animaciones en función de su modo de ahorro energético y de si está encendido el modo de ahorro con algún modo
			if os.system('echo $XDG_CURRENT_DESKTOP | grep -i gnome') == 0:
				if statOnOff == "on":
					if modo_selec == 'ahorrodeenergia':
						if statAnimations == "on":
							os.system('dconf write /org/gnome/desktop/interface/enable-animations false')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch false')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch false')
						else:
							os.system('dconf write /org/gnome/desktop/interface/enable-animations true')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch true')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch true')
					elif modo_selec == 'equilibrado':
						if statAnimations2 == "on":
							os.system('dconf write /org/gnome/desktop/interface/enable-animations false')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch false')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch false')
						else:
							os.system('dconf write /org/gnome/desktop/interface/enable-animations true')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch true')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch true')
					elif modo_selec == 'maximorendimiento':
						if statAnimations3 == "on":
							os.system('dconf write /org/gnome/desktop/interface/enable-animations false')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch false')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch false')
						else:
							os.system('dconf write /org/gnome/desktop/interface/enable-animations true')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch true')
							os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch true')
				elif statOnOff == "off":
					os.system('dconf write /org/gnome/desktop/interface/enable-animations true')
					os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-app-switch true')
					os.system('dconf write /org/gnome/shell/extensions/dash-to-panel/animate-window-launch true')

			if os.system('prime-select query') == 0:
				graphicsAfter = subprocess.getoutput('prime-select query')
				if graphicsBefore != graphicsAfter:
					rebootNvidia()

		#Si falla la autentificación vuelven los cambios realizados a como estaban anteriormente
		else:
			os.system('rm '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
			os.system('cp '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
			os.system('rm '+ user +'/.config/slimbookbattery/ahorrodeenergia_backup')

			os.system('rm '+ user +'/.config/slimbookbattery/custom/equilibrado')
			os.system('cp '+ user +'/.config/slimbookbattery/equilibrado_backup '+ user +'/.config/slimbookbattery/custom/equilibrado')
			os.system('rm '+ user +'/.config/slimbookbattery/equilibrado_backup')

			os.system('rm '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
			os.system('cp '+ user +'/.config/slimbookbattery/maximorendimiento_backup '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
			os.system('rm '+ user +'/.config/slimbookbattery/maximorendimiento_backup')

			os.system('rm '+ user +'/.config/slimbookbattery/slimbookbattery.conf')
			os.system('cp '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf '+ user +'/.config/slimbookbattery/slimbookbattery.conf')
			os.system('rm '+ user +'/.config/slimbookbattery/slimbookbattery_backup.conf')

def rebootNvidia():
	pixbuf = GdkPixbuf.Pixbuf.new_from_file_at_scale(
		filename='/usr/share/slimbookbattery/images/normal.png',
		width=90,
		height=90,
		preserve_aspect_ratio=True)
	icon_MsgDialog = Gtk.Image.new_from_pixbuf(pixbuf)
	icon_MsgDialog.show()

	dialog = Gtk.MessageDialog(type= Gtk.MessageType.QUESTION,
		buttons= Gtk.ButtonsType.YES_NO,
		message_format=(_('stralertdialog')))
	dialog.set_image(icon_MsgDialog)
	dialog.format_secondary_text((_('strmessagenvidia1')) +'\n'+ (_('strmessagenvidia2')))
	response = dialog.run()
	if response == Gtk.ResponseType.YES:
		os.system('reboot')
		#os.system('killall -u $USER')
	elif response == Gtk.ResponseType.NO:
		print(_('strprintresponsenvidia'))

	dialog.destroy()

def governorIsCompatible():
	governor = subprocess.getoutput('for i in /sys/devices/system/cpu/cpu*/cpufreq/scaling_driver; do cat $i; done')
	governor = governor.split('\n')
	governorCompatible = True
	governor_name = ''
	for governor_driver in governor:
		governor_name = governor_driver
		if governor_name != governor_driver:
			governorCompatible = False
			break
		if governor_driver != 'intel_pstate' and governor_driver != 'acpi-cpufreq':
			governorCompatible = False
			break
	
	return governorCompatible, governor_name

if __name__ == "__main__":
	cm = PreferencesDialog()
	if cm.run() == Gtk.ResponseType.ACCEPT:
		cm.close_ok()
	cm.hide()
	cm.destroy()
	exit(0)
