#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sys
import subprocess
import configparser
import gettext, locale

entorno_usu = locale.getlocale()[0]
if entorno_usu.find("en") >= 0 or entorno_usu.find("es") >= 0 or entorno_usu.find("it") >= 0 or entorno_usu.find("pt") >= 0 or entorno_usu.find("gl") >= 0:
	idiomas = [entorno_usu]
else:
	idiomas = ['en']

print('Language: ', entorno_usu)

t = gettext.translation('slimbookbattery-changemode',
                        '/usr/share/slimbookbattery/locale',
                        languages=idiomas,
                        fallback=True,)

_ = t.gettext

#Obtiene el nombre del archivo del modo de energia que va a utilizar el usuario
#Obtiene la ruta del usuario para copiar los archivos correspondientes de configuración
#Obtiene la acción a realizar (start o stop)
def main(modo, user, accion):
	config = configparser.ConfigParser()
	config.read(user + '/.config/slimbookbattery/slimbookbattery.conf')
	
	graficaNvidia = False
	if os.system('prime-select query') == 0:
		print(_('strhasnvidia'))
		graficaNvidia = True

	if accion == 'stop' and graficaNvidia == True:
		if os.system('prime-select query | grep -i intel') == 0:
			print(_('strchangesnvidiapoweroff'))
			os.system('prime-select nvidia')
	elif accion == 'start' and graficaNvidia == True:
		if config['SETTINGS']['graphics_ahorro'] == '1' and config['CONFIGURATION']['modo_actual'] == '1':
			#if os.system('prime-select query | grep -i nvidia') == 0:
				print(_('strnvidiachangestointelenergysaving'))
				print("modo 1 ahorro en 1 pongo intel") 
				os.system('prime-select intel')
			#elif os.system('prime-select query | grep -i intel') == 0:
			#	print(_('strnvidiaalredyuseintelenergysaving'))
		
		elif config['SETTINGS']['graphics_ahorro'] == '0' and config['CONFIGURATION']['modo_actual'] == '1':
			#if os.system('prime-select query | grep -i intel') == 0:
				print(_('strchangestonvidiaenergysaving'))
				print("modo 1 ahorro en 0 pongo on-demand si puedo después de intel") 
				os.system('prime-select intel')
				os.system('prime-select on-oemand')
			#elif os.system('prime-select query | grep -i nvidia') == 0:
			#	print(_('stralredyusenvidiaenergysaving'))

		elif config['SETTINGS']['graphics_equilibrado'] == '1' and config['CONFIGURATION']['modo_actual'] == '2':
			os.system('prime-select intel')
			print("Selecciono intel y abajo intentará on demand")
			print(os.system('prime-select on-demand'))
			#print(os.system('prime-select query'))
			#print("----------")
			#print(os.system('prime-select on-demand'))
			#print("----------2222")
			#if os.system('prime-select query | grep -i on-demand') == 0 and os.system('prime-select query | grep -i intel') == 0:				
			#	if os.system('prime-select query | grep -i on-demand') == 1:
			#		print(_('strchangetoondemandbalanced'))
			#		print("Permite on-demand")
			#		os.system('prime-select on-demand')
			#	else:
			#		print("NO Permite on-demand")
			#		print(_('strchangetointelbalanced'))
			#		os.system('prime-select intel')
			#elif os.system('prime-select query | grep -i nvidia') == 0:
			#	if os.system('prime-select | grep -i on-demand') == 1:
			#		print(_('stralredyuseondemandbalanced'))
			#	else:
			#		print(_('stralredyuseintelbalanced'))
			#		os.system('prime-select intel')

		elif config['SETTINGS']['graphics_equilibrado'] == '0' and config['CONFIGURATION']['modo_actual'] == '2':
			#if os.system('prime-select query | grep -i nvidia') == 0:
				print(_('strchangetonvidiadbalanced'))
				print("modo 2 ahorro en 0 pongo nvidia") 
				os.system('prime-select nvidia')
			#elif os.system('prime-select query | grep -i nvidia') == 1:
			#	print(_('stralredyusenvidiabalanced'))

		elif config['CONFIGURATION']['modo_actual'] == '3':
			#if os.system('prime-select query | grep -i intel') == 0:
				print(_('strchangestonvidiamaximumperformance'))
				os.system('prime-select nvidia')
			#elif os.system('prime-select query | grep -i nvidia') == 0:
			#	print(_('stralredyusenvidiamaximumperformance'))
	
	if graficaNvidia == False:
		if config['SETTINGS']['graphics_ahorro'] == '1':
			print(_('strmodificationtoamdintelenergysaving'))
			os.system('/usr/share/slimbookbattery/bin/graphicsamd.x 1 '+ user)

			#Se procederá a comprobar los posibles frecuencias que se pueden aplicar para apartir de ahi poder asignar valores para la frecuencia del boost, min y max, y
			#Se leen los posibles valores
			if os.path.isfile('/sys/kernel/debug/dri/0/i915_ring_freq_table'):
				freq_table = subprocess.getoutput('cat /sys/kernel/debug/dri/0/i915_ring_freq_table')
				freq_table = freq_table.split('\n')
				freq_table.pop(0)

				freq_available = ''

				for i in freq_table:
					valor = i.split()
					freq_available = freq_available + ' ' + valor[0]

				freq_available = freq_available.strip()
				#Solo se realizarán modificaciones en caso de que la variable freq_available no este vacia, ya que hay dispositivos en los que i915_ring_freq_table no existe.
				if freq_available != '':

					#Se declaran los valores por defecto
					freqCorrecta = True
					min_bat = 0
					min_ac = 0
					max_bat = 0
					max_ac = 0
					boost_bat = 0
					boost_ac = 0

					freq_available = freq_available.split(' ')
					#Si el valor que queremos se encuentra dentro del array se usará ese, sino se buscara dentro del array dentro del rango que se indica
					if int(freq_available[0]) > 0:
						min_bat = int(freq_available[0])
						min_ac = int(freq_available[0])
					else:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 0 and int(freq_available[i]) < 600):
								min_bat = int(freq_available[i])
								min_ac = int(freq_available[i])
								break
						#Si el valor que se busca no se encuentra, el boolean freqCorrecta pasará a False y por lo tanto no se realizará ninguna modificación respecto a gráficas Intel
						if min_bat == 0:
							freqCorrecta = False
						if min_ac == 0:
							freqCorrecta = False

					if '600' in freq_available and freqCorrecta == True:
						max_bat = 600
					elif '600' not in freq_available and freqCorrecta == True:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 600 and int(freq_available[i]) < 800):
								max_bat = int(freq_available[i])
								break
						if max_bat == 0:
							freqCorrecta = False

					if int(freq_available[-1]) > 0 and freqCorrecta == True:
						max_ac = int(freq_available[-1])
					if max_ac == 0:
						freqCorrecta = False

					if '800' in freq_available and freqCorrecta == True:
						boost_bat = 800
					elif '800' not in freq_available and freqCorrecta == True:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 800 and int(freq_available[i]) < int(freq_available[-1])):
								boost_bat = int(freq_available[i])
								break
						if boost_bat == 0:
							freqCorrecta = False

					if int(freq_available[-1]) > 0 and freqCorrecta == True:
						boost_ac = int(freq_available[-1])
					if boost_ac == 0:
						freqCorrecta = False
					#Si el boolean sigue en True querrá decir que se han obtenido valores para min, max y boost y se llamará al script para poder realizar las modificaciones
					if freqCorrecta == True:
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_BAT=/ cINTEL_GPU_MIN_FREQ_ON_BAT='+ str(min_bat) +'" '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_AC=/ cINTEL_GPU_MIN_FREQ_ON_AC='+ str(min_ac) +'" '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_BAT=/ cINTEL_GPU_MAX_FREQ_ON_BAT='+ str(max_bat) +'" '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_AC=/ cINTEL_GPU_MAX_FREQ_ON_AC='+ str(max_ac) +'" '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_BAT=/ cINTEL_GPU_BOOST_FREQ_ON_BAT='+ str(boost_bat) +'" '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_AC=/ cINTEL_GPU_BOOST_FREQ_ON_AC='+ str(boost_ac) +'" '+ user +'/.config/slimbookbattery/custom/ahorrodeenergia')
		else:
			print(_('stramdintelbacktodefaultenergysaving'))
			os.system('/usr/share/slimbookbattery/bin/graphicsamd.x 0 '+ user)
			os.system('/usr/share/slimbookbattery/bin/graphicsintel.x 0 '+ user)

		if config['SETTINGS']['graphics_equilibrado'] == '1':
			print(_('strmodificationsamdintel'))
			os.system('/usr/share/slimbookbattery/bin/graphicsamd2.x 1 '+ user)

			if os.path.isfile('/sys/kernel/debug/dri/0/i915_ring_freq_table'):
				
				freq_table = subprocess.getoutput('cat /sys/kernel/debug/dri/0/i915_ring_freq_table')
				freq_table = freq_table.split('\n')
				freq_table.pop(0)

				freq_available = ''

				for i in freq_table:
					valor = i.split()
					freq_available = freq_available + ' ' + valor[0]

				freq_available = freq_available.strip()

				if freq_available != '':

					freqCorrecta = True
					min_bat = 0
					min_ac = 0
					max_bat = 0
					max_ac = 0
					boost_bat = 0
					boost_ac = 0

					freq_available = freq_available.split(' ')

					if int(freq_available[0]) > 0:
						min_bat = int(freq_available[0])
						min_ac = int(freq_available[0])
					else:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 0 and int(freq_available[i]) < 600):
								min_bat = int(freq_available[i])
								min_ac = int(freq_available[i])
								break
						#Si el valor que se busca no se encuentra, el boolean freqCorrecta pasará a False y por lo tanto no se realizará ninguna modificación respecto a gráficas Intel
						if min_bat == 0:
							freqCorrecta = False
						if min_ac == 0:
							freqCorrecta = False

					if '900' in freq_available and freqCorrecta == True:
						max_bat = 900
					elif '900' not in freq_available and freqCorrecta == True:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 900 and int(freq_available[i]) < 1000):
								max_bat = int(freq_available[i])
								break
						if max_bat == 0:
							freqCorrecta = False

					if int(freq_available[-1]) > 0 and freqCorrecta == True:
						max_ac = int(freq_available[-1])
					if max_ac == 0:
						freqCorrecta = False

					if '1000' in freq_available and freqCorrecta == True:
						boost_bat = 1000
					elif '1000' not in freq_available and freqCorrecta == True:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 1000 and int(freq_available[i]) < int(freq_available[-1])):
								boost_bat = int(freq_available[i])
								break
						if boost_bat == 0:
							freqCorrecta = False

					if int(freq_available[-1]) > 0 and freqCorrecta == True:
						boost_ac = int(freq_available[-1])
					if boost_ac == 0:
						freqCorrecta = False
					#Si el boolean sigue en True querrá decir que se han obtenido valores para min, max y boost y se llamará al script para poder realizar las modificaciones
					if freqCorrecta == True:
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_BAT=/ cINTEL_GPU_MIN_FREQ_ON_BAT='+ str(min_bat) +'" '+ user +'/.config/slimbookbattery/custom/equilibrado')
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_AC=/ cINTEL_GPU_MIN_FREQ_ON_AC='+ str(min_ac) +'" '+ user +'/.config/slimbookbattery/custom/equilibrado')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_BAT=/ cINTEL_GPU_MAX_FREQ_ON_BAT='+ str(max_bat) +'" '+ user +'/.config/slimbookbattery/custom/equilibrado')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_AC=/ cINTEL_GPU_MAX_FREQ_ON_AC='+ str(max_ac) +'" '+ user +'/.config/slimbookbattery/custom/equilibrado')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_BAT=/ cINTEL_GPU_BOOST_FREQ_ON_BAT='+ str(boost_bat) +'" '+ user +'/.config/slimbookbattery/custom/equilibrado')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_AC=/ cINTEL_GPU_BOOST_FREQ_ON_AC='+ str(boost_ac) +'" '+ user +'/.config/slimbookbattery/custom/equilibrado')
		else:
			print(_('stramdintelbacktodefaultbalanced'))
			os.system('/usr/share/slimbookbattery/bin/graphicsamd2.x 0 '+ user)
			os.system('/usr/share/slimbookbattery/bin/graphicsintel2.x 0 '+ user)

		if config['CONFIGURATION']['modo_actual'] == '3':
			if os.path.isfile('/sys/kernel/debug/dri/0/i915_ring_freq_table'):
				
				freq_table = subprocess.getoutput('cat /sys/kernel/debug/dri/0/i915_ring_freq_table')
				freq_table = freq_table.split('\n')
				freq_table.pop(0)

				freq_available = ''

				for i in freq_table:
					valor = i.split()
					freq_available = freq_available + ' ' + valor[0]

				freq_available = freq_available.strip()

				if freq_available != '':

					freqCorrecta = True
					min_bat = 0
					min_ac = 0
					max_bat = 0
					max_ac = 0
					boost_bat = 0
					boost_ac = 0

					freq_available = freq_available.split(' ')

					if int(freq_available[0]) > 0:
						min_bat = int(freq_available[0])
						min_ac = int(freq_available[0])
					else:
						for i in range(len(freq_available)):
							if(int(freq_available[i]) > 0 and int(freq_available[i]) < 600):
								min_bat = int(freq_available[i])
								min_ac = int(freq_available[i])
								break
						#Si el valor que se busca no se encuentra, el boolean freqCorrecta pasará a False y por lo tanto no se realizará ninguna modificación respecto a gráficas Intel
						if min_bat == 0:
							freqCorrecta = False
						if min_ac == 0:
							freqCorrecta = False

					if int(freq_available[-1]) > 0 and freqCorrecta == True:
						max_ac = int(freq_available[-1])
						max_bat = int(freq_available[-1])
					if max_ac == 0:
						freqCorrecta = False
					if max_bat == 0:
						freqCorrecta = False

					if int(freq_available[-1]) > 0 and freqCorrecta == True:
						boost_ac = int(freq_available[-1])
						boost_bat = int(freq_available[-1])
					if boost_ac == 0:
						freqCorrecta = False
					if boost_bat == 0:
						freqCorrecta = False
					#Si el boolean sigue en True querrá decir que se han obtenido valores para min, max y boost y se llamará al script para poder realizar las modificaciones
					if freqCorrecta == True:
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_BAT=/ cINTEL_GPU_MIN_FREQ_ON_BAT='+ str(min_bat) +'" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_AC=/ cINTEL_GPU_MIN_FREQ_ON_AC='+ str(min_ac) +'" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_BAT=/ cINTEL_GPU_MAX_FREQ_ON_BAT='+ str(max_bat) +'" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_AC=/ cINTEL_GPU_MAX_FREQ_ON_AC='+ str(max_ac) +'" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_BAT=/ cINTEL_GPU_BOOST_FREQ_ON_BAT='+ str(boost_bat) +'" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_AC=/ cINTEL_GPU_BOOST_FREQ_ON_AC='+ str(boost_ac) +'" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
					else:
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_BAT=/ c#INTEL_GPU_MIN_FREQ_ON_BAT=0" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_AC=/ c#INTEL_GPU_MIN_FREQ_ON_AC=0" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_BAT=/ c#INTEL_GPU_MAX_FREQ_ON_BAT=0" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_AC=/ c#INTEL_GPU_MAX_FREQ_ON_AC=0" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_BAT=/ c#INTEL_GPU_BOOST_FREQ_ON_BAT=0" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')
						os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_AC=/ c#INTEL_GPU_BOOST_FREQ_ON_AC=0" '+ user +'/.config/slimbookbattery/custom/maximorendimiento')

	#Es necesario obtener la ruta del usuario desde el otro archivo ya que si se crea aquí una nueva variable para determinarla nos daría la ruta de root.
	if accion == 'start':
		#Para que se apliquen correctamente los cambios en necesario primero parar el servicio, sobreescribir el archivo tlp y luego se vuelve a iniciar
		#os.system('systemctl stop tlp.service')
		os.system('pkexec cp -f ' + user + '/.config/slimbookbattery/custom/' + modo + ' /etc/tlp.conf')
		print('Copy TLP conf: pkexec cp -f ' + user + '/.config/slimbookbattery/custom/' + modo + ' /etc/tlp.conf')
		#os.system('systemctl start tlp.service')
		os.system('tlp start')
		
		
		if modo == 'ahorrodeenergia':
			brightness = int(config['SETTINGS']['ahorro_brightness'])
		elif modo == 'equilibrado':
			brightness = int(config['SETTINGS']['equilibrado_brightness'])
		elif modo == 'maximorendimiento':
			brightness = int(config['SETTINGS']['maxrendimiento_brightness'])

		if os.path.isdir("/sys/class/backlight"):
			for name in os.listdir("/sys/class/backlight"):
				if os.path.isfile("/sys/class/backlight/"+ name +"/max_brightness") and os.path.isfile("/sys/class/backlight/"+ name +"/brightness"):
					brilloMax = int(subprocess.getoutput("cat /sys/class/backlight/"+ name +"/max_brightness"))
					brightness = int((brilloMax / 100) * brightness)
					print((_('strbrightness')) +str(brightness))
					os.system('/usr/share/slimbookbattery/bin/brillo.x '+ str(brightness) + ' '+ str(name))
					if not os.path.isfile("/var/spool/cron/crontabs/root"):
						os.system('cp /usr/share/slimbookbattery/root /var/spool/cron/crontabs/root')
						os.system('chmod 600 /var/spool/cron/crontabs/root')
						os.system('chgrp crontab /var/spool/cron/crontabs/root')
					if os.system('cat /var/spool/cron/crontabs/root | grep '+ str(name)) == 0:
						os.system('sed -i "/'+ str(name) +'/ c@reboot /usr/share/slimbookbattery/bin/brillo.x '+str(brightness) +' '+ str(name) +'" /var/spool/cron/crontabs/root')
					else:
						os.system("sed -i '$a @reboot /usr/share/slimbookbattery/bin/brillo.x "+ str(brightness) +" "+ str(name) +"' /var/spool/cron/crontabs/root")
	elif accion == 'stop':
		os.system('systemctl stop tlp.service')
		print("Copy TLP conf")
		os.system('pkexec cp -f ' + user + '/.config/slimbookbattery/custom/' + modo + ' /etc/tlp.conf')
		try:
			os.system("sed -i '/brillo.x/d' /var/spool/cron/crontabs/root")
		except:
			print(' ')

		if os.path.isfile('/sys/kernel/debug/dri/0/i915_ring_freq_table'):
			freq_table = subprocess.getoutput('cat /sys/kernel/debug/dri/0/i915_ring_freq_table')
			freq_table = freq_table.split('\n')
			freq_table.pop(0)

			freq_available = ''

			for i in freq_table:
				valor = i.split()
				freq_available = freq_available + ' ' + valor[0]

			freq_available = freq_available.strip()

			if freq_available != '':

				freqCorrecta = True
				min_bat = 0
				min_ac = 0
				max_bat = 0
				max_ac = 0
				boost_bat = 0
				boost_ac = 0

				freq_available = freq_available.split(' ')

				if int(freq_available[0]) > 0:
					min_bat = int(freq_available[0])
					min_ac = int(freq_available[0])
				else:
					for i in range(len(freq_available)):
						if(int(freq_available[i]) > 0 and int(freq_available[i]) < 600):
							min_bat = int(freq_available[i])
							min_ac = int(freq_available[i])
							break
					#Si el valor que se busca no se encuentra, el boolean freqCorrecta pasará a False y por lo tanto no se realizará ninguna modificación respecto a gráficas Intel
					if min_bat == 0:
						freqCorrecta = False
					if min_ac == 0:
						freqCorrecta = False

				if int(freq_available[-1]) > 0 and freqCorrecta == True:
					max_ac = int(freq_available[-1])
					max_bat = int(freq_available[-1])
				if max_ac == 0:
					freqCorrecta = False
				if max_bat == 0:
					freqCorrecta = False

				if int(freq_available[-1]) > 0 and freqCorrecta == True:
					boost_ac = int(freq_available[-1])
					boost_bat = int(freq_available[-1])
				if boost_ac == 0:
					freqCorrecta = False
				if boost_bat == 0:
					freqCorrecta = False
				#Si el boolean sigue en True querrá decir que se han obtenido valores para min, max y boost y se llamará al script para poder realizar las modificaciones
				if freqCorrecta == True:
					os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_BAT=/ cINTEL_GPU_MIN_FREQ_ON_BAT='+ str(min_bat) +'" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_AC=/ cINTEL_GPU_MIN_FREQ_ON_AC='+ str(min_ac) +'" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_BAT=/ cINTEL_GPU_MAX_FREQ_ON_BAT='+ str(max_bat) +'" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_AC=/ cINTEL_GPU_MAX_FREQ_ON_AC='+ str(max_ac) +'" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_BAT=/ cINTEL_GPU_BOOST_FREQ_ON_BAT='+ str(boost_bat) +'" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_AC=/ cINTEL_GPU_BOOST_FREQ_ON_AC='+ str(boost_ac) +'" /etc/tlp.conf')
				else:
					os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_BAT=/ c#INTEL_GPU_MIN_FREQ_ON_BAT=0" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_MIN_FREQ_ON_AC=/ c#INTEL_GPU_MIN_FREQ_ON_AC=0" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_BAT=/ c#INTEL_GPU_MAX_FREQ_ON_BAT=0" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_MAX_FREQ_ON_AC=/ c#INTEL_GPU_MAX_FREQ_ON_AC=0" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_BAT=/ c#INTEL_GPU_BOOST_FREQ_ON_BAT=0" /etc/tlp.conf')
					os.system('sed -i "/INTEL_GPU_BOOST_FREQ_ON_AC=/ c#INTEL_GPU_BOOST_FREQ_ON_AC=0" /etc/tlp.conf')

	if config['CONFIGURATION']['autostart'] == '0':
		os.system('pkexec systemctl disable tlp.service')
	elif config['CONFIGURATION']['autostart'] == '1' and config['CONFIGURATION']['application_on'] == '0':
		os.system('pkexec systemctl disable tlp.service')
	elif config['CONFIGURATION']['autostart'] == '1' and config['CONFIGURATION']['application_on'] == '1':
		os.system('pkexec systemctl enable tlp.service')
	
	if os.system("cat /sys/power/state | grep disk") == 0:
		if config['CONFIGURATION']['hibernate_after_suspension'] == '0':
			os.system('pkexec systemctl disable suspend-sedation.service')
		elif config['CONFIGURATION']['hibernate_after_suspension'] == '1':
			os.system('pkexec systemctl enable suspend-sedation.service')

if __name__ == "__main__":
	#Se obtiene las variables que se le pasa desde el archivo slimbookbattery
	main(sys.argv[1], sys.argv[2], sys.argv[3])
